/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "../src/intel/compiler/elk/elk_gram.y"

/*
 * Copyright © 2018 Intel Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include "elk_asm.h"

#undef yyerror
#ifdef YYBYACC
struct YYLTYPE;
void yyerror (struct YYLTYPE *, char *);
#else
void yyerror (char *);
#endif

#undef ALIGN16

#define YYLTYPE YYLTYPE
typedef struct YYLTYPE
{
	int first_line;
	int first_column;
	int last_line;
	int last_column;
} YYLTYPE;

enum message_level {
	WARN,
	ERROR,
};

int yydebug = 1;

static void
message(enum message_level level, YYLTYPE *location,
	const char *fmt, ...)
{
	static const char *level_str[] = { "warning", "error" };
	va_list args;

	if (location)
		fprintf(stderr, "%s:%d:%d: %s: ", input_filename,
		        location->first_line,
		        location->first_column, level_str[level]);
	else
		fprintf(stderr, "%s:%s: ", input_filename, level_str[level]);

	va_start(args, fmt);
	vfprintf(stderr, fmt, args);
	va_end(args);
}

#define warn(flag, l, fmt, ...) 				 \
	do {							 \
		if (warning_flags & WARN_ ## flag)		 \
			message(WARN, l, fmt, ## __VA_ARGS__);	 \
	} while (0)

#define error(l, fmt, ...)				   	 \
	do {						   	 \
		message(ERROR, l, fmt, ## __VA_ARGS__);	   	 \
	} while (0)

static bool
isPowerofTwo(unsigned int x)
{
	return x && (!(x & (x - 1)));
}

static struct elk_reg
set_direct_src_operand(struct elk_reg *reg, int type)
{
	return elk_reg(reg->file,
		       reg->nr,
		       reg->subnr,
		       0,		// negate
		       0,		// abs
		       type,
		       0,		// vstride
		       0,		// width
		       0,		// hstride
		       ELK_SWIZZLE_NOOP,
		       WRITEMASK_XYZW);
}

static void
i965_asm_unary_instruction(int opcode, struct elk_codegen *p,
		           struct elk_reg dest, struct elk_reg src0)
{
	switch (opcode) {
	case ELK_OPCODE_BFREV:
		elk_BFREV(p, dest, src0);
		break;
	case ELK_OPCODE_CBIT:
		elk_CBIT(p, dest, src0);
		break;
	case ELK_OPCODE_F32TO16:
		elk_F32TO16(p, dest, src0);
		break;
	case ELK_OPCODE_F16TO32:
		elk_F16TO32(p, dest, src0);
		break;
	case ELK_OPCODE_MOV:
		elk_MOV(p, dest, src0);
		break;
	case ELK_OPCODE_FBL:
		elk_FBL(p, dest, src0);
		break;
	case ELK_OPCODE_FRC:
		elk_FRC(p, dest, src0);
		break;
	case ELK_OPCODE_FBH:
		elk_FBH(p, dest, src0);
		break;
	case ELK_OPCODE_NOT:
		elk_NOT(p, dest, src0);
		break;
	case ELK_OPCODE_RNDE:
		elk_RNDE(p, dest, src0);
		break;
	case ELK_OPCODE_RNDZ:
		elk_RNDZ(p, dest, src0);
		break;
	case ELK_OPCODE_RNDD:
		elk_RNDD(p, dest, src0);
		break;
	case ELK_OPCODE_LZD:
		elk_LZD(p, dest, src0);
		break;
	case ELK_OPCODE_DIM:
		elk_DIM(p, dest, src0);
		break;
	case ELK_OPCODE_RNDU:
		fprintf(stderr, "Opcode ELK_OPCODE_RNDU unhandled\n");
		break;
	default:
		fprintf(stderr, "Unsupported unary opcode\n");
	}
}

static void
i965_asm_binary_instruction(int opcode,
			    struct elk_codegen *p,
			    struct elk_reg dest,
			    struct elk_reg src0,
			    struct elk_reg src1)
{
	switch (opcode) {
	case ELK_OPCODE_ADDC:
		elk_ADDC(p, dest, src0, src1);
		break;
	case ELK_OPCODE_BFI1:
		elk_BFI1(p, dest, src0, src1);
		break;
	case ELK_OPCODE_DP2:
		elk_DP2(p, dest, src0, src1);
		break;
	case ELK_OPCODE_DP3:
		elk_DP3(p, dest, src0, src1);
		break;
	case ELK_OPCODE_DP4:
		elk_DP4(p, dest, src0, src1);
		break;
	case ELK_OPCODE_DPH:
		elk_DPH(p, dest, src0, src1);
		break;
	case ELK_OPCODE_LINE:
		elk_LINE(p, dest, src0, src1);
		break;
	case ELK_OPCODE_MAC:
		elk_MAC(p, dest, src0, src1);
		break;
	case ELK_OPCODE_MACH:
		elk_MACH(p, dest, src0, src1);
		break;
	case ELK_OPCODE_PLN:
		elk_PLN(p, dest, src0, src1);
		break;
	case ELK_OPCODE_SAD2:
		fprintf(stderr, "Opcode ELK_OPCODE_SAD2 unhandled\n");
		break;
	case ELK_OPCODE_SADA2:
		fprintf(stderr, "Opcode ELK_OPCODE_SADA2 unhandled\n");
		break;
	case ELK_OPCODE_SUBB:
		elk_SUBB(p, dest, src0, src1);
		break;
	case ELK_OPCODE_ADD:
		elk_ADD(p, dest, src0, src1);
		break;
	case ELK_OPCODE_CMP:
		/* Third parameter is conditional modifier
		 * which gets updated later
		 */
		elk_CMP(p, dest, 0, src0, src1);
		break;
	case ELK_OPCODE_AND:
		elk_AND(p, dest, src0, src1);
		break;
	case ELK_OPCODE_ASR:
		elk_ASR(p, dest, src0, src1);
		break;
	case ELK_OPCODE_AVG:
		elk_AVG(p, dest, src0, src1);
		break;
	case ELK_OPCODE_OR:
		elk_OR(p, dest, src0, src1);
		break;
	case ELK_OPCODE_SEL:
		elk_SEL(p, dest, src0, src1);
		break;
	case ELK_OPCODE_SHL:
		elk_SHL(p, dest, src0, src1);
		break;
	case ELK_OPCODE_SHR:
		elk_SHR(p, dest, src0, src1);
		break;
	case ELK_OPCODE_XOR:
		elk_XOR(p, dest, src0, src1);
		break;
	case ELK_OPCODE_MUL:
		elk_MUL(p, dest, src0, src1);
		break;
	default:
		fprintf(stderr, "Unsupported binary opcode\n");
	}
}

static void
i965_asm_ternary_instruction(int opcode,
			     struct elk_codegen *p,
			     struct elk_reg dest,
			     struct elk_reg src0,
			     struct elk_reg src1,
			     struct elk_reg src2)
{
	switch (opcode) {
	case ELK_OPCODE_MAD:
		elk_MAD(p, dest, src0, src1, src2);
		break;
	case ELK_OPCODE_CSEL:
		elk_CSEL(p, dest, src0, src1, src2);
		break;
	case ELK_OPCODE_LRP:
		elk_LRP(p, dest, src0, src1, src2);
		break;
	case ELK_OPCODE_BFE:
		elk_BFE(p, dest, src0, src1, src2);
		break;
	case ELK_OPCODE_BFI2:
		elk_BFI2(p, dest, src0, src1, src2);
		break;
	default:
		fprintf(stderr, "Unsupported ternary opcode\n");
	}
}

static void
i965_asm_set_instruction_options(struct elk_codegen *p,
				 struct options options)
{
	elk_inst_set_access_mode(p->devinfo, elk_last_inst,
			         options.access_mode);
	elk_inst_set_mask_control(p->devinfo, elk_last_inst,
				  options.mask_control);
        elk_inst_set_thread_control(p->devinfo, elk_last_inst,
                                    options.thread_control);
        elk_inst_set_no_dd_check(p->devinfo, elk_last_inst,
                                 options.no_dd_check);
        elk_inst_set_no_dd_clear(p->devinfo, elk_last_inst,
                                 options.no_dd_clear);
	elk_inst_set_debug_control(p->devinfo, elk_last_inst,
			           options.debug_control);
	if (elk_has_branch_ctrl(p->devinfo, elk_inst_opcode(p->isa, elk_last_inst))) {
		if (options.acc_wr_control)
			error(NULL, "Instruction does not support AccWrEnable\n");

		elk_inst_set_branch_control(p->devinfo, elk_last_inst,
		                            options.branch_control);
	} else if (options.branch_control) {
		error(NULL, "Instruction does not support BranchCtrl\n");
	} else if (p->devinfo->ver >= 6) {
		elk_inst_set_acc_wr_control(p->devinfo, elk_last_inst,
					    options.acc_wr_control);
	}
	elk_inst_set_cmpt_control(p->devinfo, elk_last_inst,
				  options.compaction);
}

static void
i965_asm_set_dst_nr(struct elk_codegen *p,
	            struct elk_reg *reg,
	            struct options options)
{
	if (p->devinfo->ver <= 6) {
		if (reg->file == ELK_MESSAGE_REGISTER_FILE &&
		    options.qtr_ctrl == ELK_COMPRESSION_COMPRESSED &&
		    !options.is_compr)
			reg->nr |= ELK_MRF_COMPR4;
	}
}

static void
add_label(struct elk_codegen *p, const char* label_name, enum instr_label_type type)
{
	if (!label_name) {
		return;
	}

	struct instr_label *label = rzalloc(p->mem_ctx, struct instr_label);

	label->name = ralloc_strdup(p->mem_ctx, label_name);
	label->offset = p->next_insn_offset;
	label->type = type;

	list_addtail(&label->link, &instr_labels);
}


#line 414 "src/intel/compiler/elk/elk_gram.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "elk_gram.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ABS = 3,                        /* ABS  */
  YYSYMBOL_COLON = 4,                      /* COLON  */
  YYSYMBOL_COMMA = 5,                      /* COMMA  */
  YYSYMBOL_DOT = 6,                        /* DOT  */
  YYSYMBOL_LANGLE = 7,                     /* LANGLE  */
  YYSYMBOL_RANGLE = 8,                     /* RANGLE  */
  YYSYMBOL_LCURLY = 9,                     /* LCURLY  */
  YYSYMBOL_RCURLY = 10,                    /* RCURLY  */
  YYSYMBOL_LPAREN = 11,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 12,                    /* RPAREN  */
  YYSYMBOL_LSQUARE = 13,                   /* LSQUARE  */
  YYSYMBOL_RSQUARE = 14,                   /* RSQUARE  */
  YYSYMBOL_PLUS = 15,                      /* PLUS  */
  YYSYMBOL_MINUS = 16,                     /* MINUS  */
  YYSYMBOL_SEMICOLON = 17,                 /* SEMICOLON  */
  YYSYMBOL_ASSIGN = 18,                    /* ASSIGN  */
  YYSYMBOL_TYPE_B = 19,                    /* TYPE_B  */
  YYSYMBOL_TYPE_UB = 20,                   /* TYPE_UB  */
  YYSYMBOL_TYPE_W = 21,                    /* TYPE_W  */
  YYSYMBOL_TYPE_UW = 22,                   /* TYPE_UW  */
  YYSYMBOL_TYPE_D = 23,                    /* TYPE_D  */
  YYSYMBOL_TYPE_UD = 24,                   /* TYPE_UD  */
  YYSYMBOL_TYPE_Q = 25,                    /* TYPE_Q  */
  YYSYMBOL_TYPE_UQ = 26,                   /* TYPE_UQ  */
  YYSYMBOL_TYPE_V = 27,                    /* TYPE_V  */
  YYSYMBOL_TYPE_UV = 28,                   /* TYPE_UV  */
  YYSYMBOL_TYPE_F = 29,                    /* TYPE_F  */
  YYSYMBOL_TYPE_HF = 30,                   /* TYPE_HF  */
  YYSYMBOL_TYPE_DF = 31,                   /* TYPE_DF  */
  YYSYMBOL_TYPE_NF = 32,                   /* TYPE_NF  */
  YYSYMBOL_TYPE_VF = 33,                   /* TYPE_VF  */
  YYSYMBOL_JUMP_LABEL = 34,                /* JUMP_LABEL  */
  YYSYMBOL_JUMP_LABEL_TARGET = 35,         /* JUMP_LABEL_TARGET  */
  YYSYMBOL_ADD = 36,                       /* ADD  */
  YYSYMBOL_ADDC = 37,                      /* ADDC  */
  YYSYMBOL_AND = 38,                       /* AND  */
  YYSYMBOL_ASR = 39,                       /* ASR  */
  YYSYMBOL_AVG = 40,                       /* AVG  */
  YYSYMBOL_BFE = 41,                       /* BFE  */
  YYSYMBOL_BFI1 = 42,                      /* BFI1  */
  YYSYMBOL_BFI2 = 43,                      /* BFI2  */
  YYSYMBOL_BFB = 44,                       /* BFB  */
  YYSYMBOL_BFREV = 45,                     /* BFREV  */
  YYSYMBOL_BRC = 46,                       /* BRC  */
  YYSYMBOL_BRD = 47,                       /* BRD  */
  YYSYMBOL_BREAK = 48,                     /* BREAK  */
  YYSYMBOL_CALL = 49,                      /* CALL  */
  YYSYMBOL_CALLA = 50,                     /* CALLA  */
  YYSYMBOL_CASE = 51,                      /* CASE  */
  YYSYMBOL_CBIT = 52,                      /* CBIT  */
  YYSYMBOL_CMP = 53,                       /* CMP  */
  YYSYMBOL_CMPN = 54,                      /* CMPN  */
  YYSYMBOL_CONT = 55,                      /* CONT  */
  YYSYMBOL_CSEL = 56,                      /* CSEL  */
  YYSYMBOL_DIM = 57,                       /* DIM  */
  YYSYMBOL_DO = 58,                        /* DO  */
  YYSYMBOL_DP2 = 59,                       /* DP2  */
  YYSYMBOL_DP3 = 60,                       /* DP3  */
  YYSYMBOL_DP4 = 61,                       /* DP4  */
  YYSYMBOL_DPH = 62,                       /* DPH  */
  YYSYMBOL_ELSE = 63,                      /* ELSE  */
  YYSYMBOL_ENDIF = 64,                     /* ENDIF  */
  YYSYMBOL_F16TO32 = 65,                   /* F16TO32  */
  YYSYMBOL_F32TO16 = 66,                   /* F32TO16  */
  YYSYMBOL_FBH = 67,                       /* FBH  */
  YYSYMBOL_FBL = 68,                       /* FBL  */
  YYSYMBOL_FORK = 69,                      /* FORK  */
  YYSYMBOL_FRC = 70,                       /* FRC  */
  YYSYMBOL_GOTO = 71,                      /* GOTO  */
  YYSYMBOL_HALT = 72,                      /* HALT  */
  YYSYMBOL_IF = 73,                        /* IF  */
  YYSYMBOL_IFF = 74,                       /* IFF  */
  YYSYMBOL_ILLEGAL = 75,                   /* ILLEGAL  */
  YYSYMBOL_JMPI = 76,                      /* JMPI  */
  YYSYMBOL_JOIN = 77,                      /* JOIN  */
  YYSYMBOL_LINE = 78,                      /* LINE  */
  YYSYMBOL_LRP = 79,                       /* LRP  */
  YYSYMBOL_LZD = 80,                       /* LZD  */
  YYSYMBOL_MAC = 81,                       /* MAC  */
  YYSYMBOL_MACH = 82,                      /* MACH  */
  YYSYMBOL_MAD = 83,                       /* MAD  */
  YYSYMBOL_MADM = 84,                      /* MADM  */
  YYSYMBOL_MOV = 85,                       /* MOV  */
  YYSYMBOL_MOVI = 86,                      /* MOVI  */
  YYSYMBOL_MUL = 87,                       /* MUL  */
  YYSYMBOL_MREST = 88,                     /* MREST  */
  YYSYMBOL_MSAVE = 89,                     /* MSAVE  */
  YYSYMBOL_NENOP = 90,                     /* NENOP  */
  YYSYMBOL_NOP = 91,                       /* NOP  */
  YYSYMBOL_NOT = 92,                       /* NOT  */
  YYSYMBOL_OR = 93,                        /* OR  */
  YYSYMBOL_PLN = 94,                       /* PLN  */
  YYSYMBOL_POP = 95,                       /* POP  */
  YYSYMBOL_PUSH = 96,                      /* PUSH  */
  YYSYMBOL_RET = 97,                       /* RET  */
  YYSYMBOL_RNDD = 98,                      /* RNDD  */
  YYSYMBOL_RNDE = 99,                      /* RNDE  */
  YYSYMBOL_RNDU = 100,                     /* RNDU  */
  YYSYMBOL_RNDZ = 101,                     /* RNDZ  */
  YYSYMBOL_SAD2 = 102,                     /* SAD2  */
  YYSYMBOL_SADA2 = 103,                    /* SADA2  */
  YYSYMBOL_SEL = 104,                      /* SEL  */
  YYSYMBOL_SHL = 105,                      /* SHL  */
  YYSYMBOL_SHR = 106,                      /* SHR  */
  YYSYMBOL_SMOV = 107,                     /* SMOV  */
  YYSYMBOL_SUBB = 108,                     /* SUBB  */
  YYSYMBOL_SEND = 109,                     /* SEND  */
  YYSYMBOL_SENDC = 110,                    /* SENDC  */
  YYSYMBOL_WAIT = 111,                     /* WAIT  */
  YYSYMBOL_WHILE = 112,                    /* WHILE  */
  YYSYMBOL_XOR = 113,                      /* XOR  */
  YYSYMBOL_COS = 114,                      /* COS  */
  YYSYMBOL_EXP = 115,                      /* EXP  */
  YYSYMBOL_FDIV = 116,                     /* FDIV  */
  YYSYMBOL_INV = 117,                      /* INV  */
  YYSYMBOL_INVM = 118,                     /* INVM  */
  YYSYMBOL_INTDIV = 119,                   /* INTDIV  */
  YYSYMBOL_INTDIVMOD = 120,                /* INTDIVMOD  */
  YYSYMBOL_INTMOD = 121,                   /* INTMOD  */
  YYSYMBOL_LOG = 122,                      /* LOG  */
  YYSYMBOL_POW = 123,                      /* POW  */
  YYSYMBOL_RSQ = 124,                      /* RSQ  */
  YYSYMBOL_RSQRTM = 125,                   /* RSQRTM  */
  YYSYMBOL_SIN = 126,                      /* SIN  */
  YYSYMBOL_SINCOS = 127,                   /* SINCOS  */
  YYSYMBOL_SQRT = 128,                     /* SQRT  */
  YYSYMBOL_CONST = 129,                    /* CONST  */
  YYSYMBOL_CRE = 130,                      /* CRE  */
  YYSYMBOL_DATA = 131,                     /* DATA  */
  YYSYMBOL_DP_DATA_1 = 132,                /* DP_DATA_1  */
  YYSYMBOL_GATEWAY = 133,                  /* GATEWAY  */
  YYSYMBOL_MATH = 134,                     /* MATH  */
  YYSYMBOL_PIXEL_INTERP = 135,             /* PIXEL_INTERP  */
  YYSYMBOL_READ = 136,                     /* READ  */
  YYSYMBOL_RENDER = 137,                   /* RENDER  */
  YYSYMBOL_SAMPLER = 138,                  /* SAMPLER  */
  YYSYMBOL_THREAD_SPAWNER = 139,           /* THREAD_SPAWNER  */
  YYSYMBOL_URB = 140,                      /* URB  */
  YYSYMBOL_VME = 141,                      /* VME  */
  YYSYMBOL_WRITE = 142,                    /* WRITE  */
  YYSYMBOL_DP_SAMPLER = 143,               /* DP_SAMPLER  */
  YYSYMBOL_RT_ACCEL = 144,                 /* RT_ACCEL  */
  YYSYMBOL_SLM = 145,                      /* SLM  */
  YYSYMBOL_TGM = 146,                      /* TGM  */
  YYSYMBOL_UGM = 147,                      /* UGM  */
  YYSYMBOL_MSGDESC_BEGIN = 148,            /* MSGDESC_BEGIN  */
  YYSYMBOL_SRC1_LEN = 149,                 /* SRC1_LEN  */
  YYSYMBOL_EX_BSO = 150,                   /* EX_BSO  */
  YYSYMBOL_MSGDESC_END = 151,              /* MSGDESC_END  */
  YYSYMBOL_EQUAL = 152,                    /* EQUAL  */
  YYSYMBOL_GREATER = 153,                  /* GREATER  */
  YYSYMBOL_GREATER_EQUAL = 154,            /* GREATER_EQUAL  */
  YYSYMBOL_LESS = 155,                     /* LESS  */
  YYSYMBOL_LESS_EQUAL = 156,               /* LESS_EQUAL  */
  YYSYMBOL_NOT_EQUAL = 157,                /* NOT_EQUAL  */
  YYSYMBOL_NOT_ZERO = 158,                 /* NOT_ZERO  */
  YYSYMBOL_OVERFLOW = 159,                 /* OVERFLOW  */
  YYSYMBOL_UNORDERED = 160,                /* UNORDERED  */
  YYSYMBOL_ZERO = 161,                     /* ZERO  */
  YYSYMBOL_ALIGN1 = 162,                   /* ALIGN1  */
  YYSYMBOL_ALIGN16 = 163,                  /* ALIGN16  */
  YYSYMBOL_ACCWREN = 164,                  /* ACCWREN  */
  YYSYMBOL_CMPTCTRL = 165,                 /* CMPTCTRL  */
  YYSYMBOL_COMPR = 166,                    /* COMPR  */
  YYSYMBOL_COMPR4 = 167,                   /* COMPR4  */
  YYSYMBOL_SECHALF = 168,                  /* SECHALF  */
  YYSYMBOL_WECTRL = 169,                   /* WECTRL  */
  YYSYMBOL_BREAKPOINT = 170,               /* BREAKPOINT  */
  YYSYMBOL_NODDCLR = 171,                  /* NODDCLR  */
  YYSYMBOL_NODDCHK = 172,                  /* NODDCHK  */
  YYSYMBOL_EOT = 173,                      /* EOT  */
  YYSYMBOL_MASK_DISABLE = 174,             /* MASK_DISABLE  */
  YYSYMBOL_ANYV = 175,                     /* ANYV  */
  YYSYMBOL_ALLV = 176,                     /* ALLV  */
  YYSYMBOL_ANY2H = 177,                    /* ANY2H  */
  YYSYMBOL_ALL2H = 178,                    /* ALL2H  */
  YYSYMBOL_ANY4H = 179,                    /* ANY4H  */
  YYSYMBOL_ALL4H = 180,                    /* ALL4H  */
  YYSYMBOL_ANY8H = 181,                    /* ANY8H  */
  YYSYMBOL_ALL8H = 182,                    /* ALL8H  */
  YYSYMBOL_ANY16H = 183,                   /* ANY16H  */
  YYSYMBOL_ALL16H = 184,                   /* ALL16H  */
  YYSYMBOL_ANY32H = 185,                   /* ANY32H  */
  YYSYMBOL_ALL32H = 186,                   /* ALL32H  */
  YYSYMBOL_ROUND_INCREMENT = 187,          /* ROUND_INCREMENT  */
  YYSYMBOL_SATURATE = 188,                 /* SATURATE  */
  YYSYMBOL_ATOMIC = 189,                   /* ATOMIC  */
  YYSYMBOL_SWITCH = 190,                   /* SWITCH  */
  YYSYMBOL_BRANCH_CTRL = 191,              /* BRANCH_CTRL  */
  YYSYMBOL_QTR_2Q = 192,                   /* QTR_2Q  */
  YYSYMBOL_QTR_3Q = 193,                   /* QTR_3Q  */
  YYSYMBOL_QTR_4Q = 194,                   /* QTR_4Q  */
  YYSYMBOL_QTR_2H = 195,                   /* QTR_2H  */
  YYSYMBOL_QTR_2N = 196,                   /* QTR_2N  */
  YYSYMBOL_QTR_3N = 197,                   /* QTR_3N  */
  YYSYMBOL_QTR_4N = 198,                   /* QTR_4N  */
  YYSYMBOL_QTR_5N = 199,                   /* QTR_5N  */
  YYSYMBOL_QTR_6N = 200,                   /* QTR_6N  */
  YYSYMBOL_QTR_7N = 201,                   /* QTR_7N  */
  YYSYMBOL_QTR_8N = 202,                   /* QTR_8N  */
  YYSYMBOL_X = 203,                        /* X  */
  YYSYMBOL_Y = 204,                        /* Y  */
  YYSYMBOL_Z = 205,                        /* Z  */
  YYSYMBOL_W = 206,                        /* W  */
  YYSYMBOL_GENREGFILE = 207,               /* GENREGFILE  */
  YYSYMBOL_MSGREGFILE = 208,               /* MSGREGFILE  */
  YYSYMBOL_VxH = 209,                      /* VxH  */
  YYSYMBOL_GENREG = 210,                   /* GENREG  */
  YYSYMBOL_MSGREG = 211,                   /* MSGREG  */
  YYSYMBOL_ADDRREG = 212,                  /* ADDRREG  */
  YYSYMBOL_ACCREG = 213,                   /* ACCREG  */
  YYSYMBOL_FLAGREG = 214,                  /* FLAGREG  */
  YYSYMBOL_NOTIFYREG = 215,                /* NOTIFYREG  */
  YYSYMBOL_STATEREG = 216,                 /* STATEREG  */
  YYSYMBOL_CONTROLREG = 217,               /* CONTROLREG  */
  YYSYMBOL_IPREG = 218,                    /* IPREG  */
  YYSYMBOL_PERFORMANCEREG = 219,           /* PERFORMANCEREG  */
  YYSYMBOL_THREADREG = 220,                /* THREADREG  */
  YYSYMBOL_CHANNELENABLEREG = 221,         /* CHANNELENABLEREG  */
  YYSYMBOL_MASKREG = 222,                  /* MASKREG  */
  YYSYMBOL_INTEGER = 223,                  /* INTEGER  */
  YYSYMBOL_LONG = 224,                     /* LONG  */
  YYSYMBOL_NULL_TOKEN = 225,               /* NULL_TOKEN  */
  YYSYMBOL_SUBREGNUM = 226,                /* SUBREGNUM  */
  YYSYMBOL_EMPTYEXECSIZE = 227,            /* EMPTYEXECSIZE  */
  YYSYMBOL_YYACCEPT = 228,                 /* $accept  */
  YYSYMBOL_ROOT = 229,                     /* ROOT  */
  YYSYMBOL_instrseq = 230,                 /* instrseq  */
  YYSYMBOL_instruction = 231,              /* instruction  */
  YYSYMBOL_relocatableinstruction = 232,   /* relocatableinstruction  */
  YYSYMBOL_illegalinstruction = 233,       /* illegalinstruction  */
  YYSYMBOL_unaryinstruction = 234,         /* unaryinstruction  */
  YYSYMBOL_unaryopcodes = 235,             /* unaryopcodes  */
  YYSYMBOL_binaryinstruction = 236,        /* binaryinstruction  */
  YYSYMBOL_binaryopcodes = 237,            /* binaryopcodes  */
  YYSYMBOL_binaryaccinstruction = 238,     /* binaryaccinstruction  */
  YYSYMBOL_binaryaccopcodes = 239,         /* binaryaccopcodes  */
  YYSYMBOL_mathinstruction = 240,          /* mathinstruction  */
  YYSYMBOL_math_function = 241,            /* math_function  */
  YYSYMBOL_nopinstruction = 242,           /* nopinstruction  */
  YYSYMBOL_ternaryinstruction = 243,       /* ternaryinstruction  */
  YYSYMBOL_ternaryopcodes = 244,           /* ternaryopcodes  */
  YYSYMBOL_waitinstruction = 245,          /* waitinstruction  */
  YYSYMBOL_sendinstruction = 246,          /* sendinstruction  */
  YYSYMBOL_sendop = 247,                   /* sendop  */
  YYSYMBOL_sendopcode = 248,               /* sendopcode  */
  YYSYMBOL_sharedfunction = 249,           /* sharedfunction  */
  YYSYMBOL_exp2 = 250,                     /* exp2  */
  YYSYMBOL_jumpinstruction = 251,          /* jumpinstruction  */
  YYSYMBOL_branchinstruction = 252,        /* branchinstruction  */
  YYSYMBOL_breakinstruction = 253,         /* breakinstruction  */
  YYSYMBOL_loopinstruction = 254,          /* loopinstruction  */
  YYSYMBOL_relativelocation2 = 255,        /* relativelocation2  */
  YYSYMBOL_simple_int = 256,               /* simple_int  */
  YYSYMBOL_rellocation = 257,              /* rellocation  */
  YYSYMBOL_relativelocation = 258,         /* relativelocation  */
  YYSYMBOL_jumplabel = 259,                /* jumplabel  */
  YYSYMBOL_jumplabeltarget = 260,          /* jumplabeltarget  */
  YYSYMBOL_dst = 261,                      /* dst  */
  YYSYMBOL_dstoperand = 262,               /* dstoperand  */
  YYSYMBOL_dstoperandex = 263,             /* dstoperandex  */
  YYSYMBOL_dstoperandex_typed = 264,       /* dstoperandex_typed  */
  YYSYMBOL_dstreg = 265,                   /* dstreg  */
  YYSYMBOL_srcaccimm = 266,                /* srcaccimm  */
  YYSYMBOL_immreg = 267,                   /* immreg  */
  YYSYMBOL_reg32 = 268,                    /* reg32  */
  YYSYMBOL_payload = 269,                  /* payload  */
  YYSYMBOL_src = 270,                      /* src  */
  YYSYMBOL_srcacc = 271,                   /* srcacc  */
  YYSYMBOL_srcimm = 272,                   /* srcimm  */
  YYSYMBOL_directsrcaccoperand = 273,      /* directsrcaccoperand  */
  YYSYMBOL_srcarcoperandex = 274,          /* srcarcoperandex  */
  YYSYMBOL_srcarcoperandex_typed = 275,    /* srcarcoperandex_typed  */
  YYSYMBOL_indirectsrcoperand = 276,       /* indirectsrcoperand  */
  YYSYMBOL_directgenreg_list = 277,        /* directgenreg_list  */
  YYSYMBOL_directsrcoperand = 278,         /* directsrcoperand  */
  YYSYMBOL_addrparam = 279,                /* addrparam  */
  YYSYMBOL_exp = 280,                      /* exp  */
  YYSYMBOL_subregnum = 281,                /* subregnum  */
  YYSYMBOL_directgenreg = 282,             /* directgenreg  */
  YYSYMBOL_indirectgenreg = 283,           /* indirectgenreg  */
  YYSYMBOL_directmsgreg = 284,             /* directmsgreg  */
  YYSYMBOL_indirectmsgreg = 285,           /* indirectmsgreg  */
  YYSYMBOL_addrreg = 286,                  /* addrreg  */
  YYSYMBOL_accreg = 287,                   /* accreg  */
  YYSYMBOL_flagreg = 288,                  /* flagreg  */
  YYSYMBOL_maskreg = 289,                  /* maskreg  */
  YYSYMBOL_notifyreg = 290,                /* notifyreg  */
  YYSYMBOL_statereg = 291,                 /* statereg  */
  YYSYMBOL_controlreg = 292,               /* controlreg  */
  YYSYMBOL_ipreg = 293,                    /* ipreg  */
  YYSYMBOL_nullreg = 294,                  /* nullreg  */
  YYSYMBOL_threadcontrolreg = 295,         /* threadcontrolreg  */
  YYSYMBOL_performancereg = 296,           /* performancereg  */
  YYSYMBOL_channelenablereg = 297,         /* channelenablereg  */
  YYSYMBOL_immval = 298,                   /* immval  */
  YYSYMBOL_dstregion = 299,                /* dstregion  */
  YYSYMBOL_indirectregion = 300,           /* indirectregion  */
  YYSYMBOL_region = 301,                   /* region  */
  YYSYMBOL_region_wh = 302,                /* region_wh  */
  YYSYMBOL_reg_type = 303,                 /* reg_type  */
  YYSYMBOL_imm_type = 304,                 /* imm_type  */
  YYSYMBOL_writemask = 305,                /* writemask  */
  YYSYMBOL_writemask_x = 306,              /* writemask_x  */
  YYSYMBOL_writemask_y = 307,              /* writemask_y  */
  YYSYMBOL_writemask_z = 308,              /* writemask_z  */
  YYSYMBOL_writemask_w = 309,              /* writemask_w  */
  YYSYMBOL_swizzle = 310,                  /* swizzle  */
  YYSYMBOL_chansel = 311,                  /* chansel  */
  YYSYMBOL_predicate = 312,                /* predicate  */
  YYSYMBOL_predstate = 313,                /* predstate  */
  YYSYMBOL_predctrl = 314,                 /* predctrl  */
  YYSYMBOL_negate = 315,                   /* negate  */
  YYSYMBOL_abs = 316,                      /* abs  */
  YYSYMBOL_cond_mod = 317,                 /* cond_mod  */
  YYSYMBOL_condModifiers = 318,            /* condModifiers  */
  YYSYMBOL_msgdesc = 319,                  /* msgdesc  */
  YYSYMBOL_msgdesc_parts = 320,            /* msgdesc_parts  */
  YYSYMBOL_saturate = 321,                 /* saturate  */
  YYSYMBOL_execsize = 322,                 /* execsize  */
  YYSYMBOL_instoptions = 323,              /* instoptions  */
  YYSYMBOL_instoption_list = 324,          /* instoption_list  */
  YYSYMBOL_instoption = 325                /* instoption  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;



/* Unqualified %code blocks.  */
#line 553 "../src/intel/compiler/elk/elk_gram.y"


static void
add_instruction_option(struct options *options, struct instoption opt)
{
	switch (opt.uint_value) {
	case ALIGN1:
		options->access_mode = ELK_ALIGN_1;
		break;
	case ALIGN16:
		options->access_mode = ELK_ALIGN_16;
		break;
	case SECHALF:
		options->qtr_ctrl |= ELK_COMPRESSION_2NDHALF;
		break;
	case COMPR:
		options->qtr_ctrl |= ELK_COMPRESSION_COMPRESSED;
		options->is_compr = true;
		break;
	case COMPR4:
		options->qtr_ctrl |= ELK_COMPRESSION_COMPRESSED;
		break;
	case SWITCH:
		options->thread_control |= ELK_THREAD_SWITCH;
		break;
	case ATOMIC:
		options->thread_control |= ELK_THREAD_ATOMIC;
		break;
	case BRANCH_CTRL:
		options->branch_control = true;
		break;
	case NODDCHK:
		options->no_dd_check = true;
		break;
	case NODDCLR:
		options->no_dd_clear = ELK_DEPENDENCY_NOTCLEARED;
		break;
	case MASK_DISABLE:
		options->mask_control |= ELK_MASK_DISABLE;
		break;
	case BREAKPOINT:
		options->debug_control = ELK_DEBUG_BREAKPOINT;
		break;
	case WECTRL:
		options->mask_control |= ELK_WE_ALL;
		break;
	case CMPTCTRL:
		options->compaction = true;
		break;
	case ACCWREN:
		options->acc_wr_control = true;
		break;
	case EOT:
		options->end_of_thread = true;
		break;
	/* TODO : Figure out how to set instruction group and get rid of
	 * code below
	 */
	case QTR_2Q:
		options->qtr_ctrl = ELK_COMPRESSION_2NDHALF;
		break;
	case QTR_3Q:
		options->qtr_ctrl = ELK_COMPRESSION_COMPRESSED;
		break;
	case QTR_4Q:
		options->qtr_ctrl = 3;
		break;
	case QTR_2H:
		options->qtr_ctrl = ELK_COMPRESSION_COMPRESSED;
		break;
	case QTR_2N:
		options->qtr_ctrl = ELK_COMPRESSION_NONE;
		options->nib_ctrl = true;
		break;
	case QTR_3N:
		options->qtr_ctrl = ELK_COMPRESSION_2NDHALF;
		break;
	case QTR_4N:
		options->qtr_ctrl = ELK_COMPRESSION_2NDHALF;
		options->nib_ctrl = true;
		break;
	case QTR_5N:
		options->qtr_ctrl = ELK_COMPRESSION_COMPRESSED;
		break;
	case QTR_6N:
		options->qtr_ctrl = ELK_COMPRESSION_COMPRESSED;
		options->nib_ctrl = true;
		break;
	case QTR_7N:
		options->qtr_ctrl = 3;
		break;
	case QTR_8N:
		options->qtr_ctrl = 3;
		options->nib_ctrl = true;
		break;
	}
}

#line 873 "src/intel/compiler/elk/elk_gram.tab.c"

#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  35
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   749

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  228
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  98
/* YYNRULES -- Number of rules.  */
#define YYNRULES  342
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  536

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   482


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   654,   654,   658,   659,   660,   661,   662,   663,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   680,   681,
     682,   683,   687,   697,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,   747,   748,   753,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   803,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   851,   871,   872,   873,
     874,   875,   876,   877,   878,   879,   880,   881,   882,   883,
     884,   885,   890,   898,   927,   928,   929,   930,   931,   936,
     955,   977,   998,  1022,  1023,  1027,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1050,  1051,  1056,  1073,  1099,  1117,  1144,  1160,
    1194,  1212,  1244,  1265,  1288,  1302,  1324,  1343,  1362,  1396,
    1410,  1427,  1428,  1432,  1433,  1434,  1435,  1439,  1440,  1444,
    1451,  1452,  1456,  1469,  1470,  1474,  1488,  1500,  1509,  1518,
    1519,  1520,  1521,  1522,  1523,  1524,  1525,  1526,  1527,  1531,
    1536,  1541,  1546,  1555,  1556,  1560,  1611,  1619,  1623,  1624,
    1628,  1629,  1633,  1634,  1635,  1639,  1640,  1652,  1666,  1673,
    1680,  1681,  1682,  1683,  1684,  1685,  1689,  1710,  1711,  1712,
    1713,  1714,  1718,  1732,  1737,  1743,  1748,  1749,  1753,  1754,
    1758,  1768,  1778,  1787,  1797,  1812,  1832,  1852,  1865,  1879,
    1896,  1909,  1913,  1917,  1930,  1949,  1963,  1967,  1976,  1979,
    1989,  1990,  1995,  1998,  2005,  2020,  2034,  2048,  2063,  2064,
    2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,
    2078,  2079,  2080,  2081,  2086,  2089,  2096,  2097,  2101,  2102,
    2106,  2107,  2111,  2112,  2117,  2120,  2124,  2131,  2132,  2133,
    2134,  2140,  2146,  2156,  2157,  2158,  2162,  2163,  2164,  2165,
    2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,  2175,
    2176,  2177,  2178,  2183,  2184,  2188,  2189,  2194,  2200,  2209,
    2210,  2211,  2212,  2213,  2214,  2215,  2216,  2217,  2218,  2219,
    2220,  2225,  2229,  2234,  2239,  2240,  2242,  2248,  2249,  2254,
    2258,  2270,  2273,  2281,  2287,  2294,  2300,  2301,  2302,  2308,
    2309,  2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,
    2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,
    2334,  2335,  2336
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ABS", "COLON",
  "COMMA", "DOT", "LANGLE", "RANGLE", "LCURLY", "RCURLY", "LPAREN",
  "RPAREN", "LSQUARE", "RSQUARE", "PLUS", "MINUS", "SEMICOLON", "ASSIGN",
  "TYPE_B", "TYPE_UB", "TYPE_W", "TYPE_UW", "TYPE_D", "TYPE_UD", "TYPE_Q",
  "TYPE_UQ", "TYPE_V", "TYPE_UV", "TYPE_F", "TYPE_HF", "TYPE_DF",
  "TYPE_NF", "TYPE_VF", "JUMP_LABEL", "JUMP_LABEL_TARGET", "ADD", "ADDC",
  "AND", "ASR", "AVG", "BFE", "BFI1", "BFI2", "BFB", "BFREV", "BRC", "BRD",
  "BREAK", "CALL", "CALLA", "CASE", "CBIT", "CMP", "CMPN", "CONT", "CSEL",
  "DIM", "DO", "DP2", "DP3", "DP4", "DPH", "ELSE", "ENDIF", "F16TO32",
  "F32TO16", "FBH", "FBL", "FORK", "FRC", "GOTO", "HALT", "IF", "IFF",
  "ILLEGAL", "JMPI", "JOIN", "LINE", "LRP", "LZD", "MAC", "MACH", "MAD",
  "MADM", "MOV", "MOVI", "MUL", "MREST", "MSAVE", "NENOP", "NOP", "NOT",
  "OR", "PLN", "POP", "PUSH", "RET", "RNDD", "RNDE", "RNDU", "RNDZ",
  "SAD2", "SADA2", "SEL", "SHL", "SHR", "SMOV", "SUBB", "SEND", "SENDC",
  "WAIT", "WHILE", "XOR", "COS", "EXP", "FDIV", "INV", "INVM", "INTDIV",
  "INTDIVMOD", "INTMOD", "LOG", "POW", "RSQ", "RSQRTM", "SIN", "SINCOS",
  "SQRT", "CONST", "CRE", "DATA", "DP_DATA_1", "GATEWAY", "MATH",
  "PIXEL_INTERP", "READ", "RENDER", "SAMPLER", "THREAD_SPAWNER", "URB",
  "VME", "WRITE", "DP_SAMPLER", "RT_ACCEL", "SLM", "TGM", "UGM",
  "MSGDESC_BEGIN", "SRC1_LEN", "EX_BSO", "MSGDESC_END", "EQUAL", "GREATER",
  "GREATER_EQUAL", "LESS", "LESS_EQUAL", "NOT_EQUAL", "NOT_ZERO",
  "OVERFLOW", "UNORDERED", "ZERO", "ALIGN1", "ALIGN16", "ACCWREN",
  "CMPTCTRL", "COMPR", "COMPR4", "SECHALF", "WECTRL", "BREAKPOINT",
  "NODDCLR", "NODDCHK", "EOT", "MASK_DISABLE", "ANYV", "ALLV", "ANY2H",
  "ALL2H", "ANY4H", "ALL4H", "ANY8H", "ALL8H", "ANY16H", "ALL16H",
  "ANY32H", "ALL32H", "ROUND_INCREMENT", "SATURATE", "ATOMIC", "SWITCH",
  "BRANCH_CTRL", "QTR_2Q", "QTR_3Q", "QTR_4Q", "QTR_2H", "QTR_2N",
  "QTR_3N", "QTR_4N", "QTR_5N", "QTR_6N", "QTR_7N", "QTR_8N", "X", "Y",
  "Z", "W", "GENREGFILE", "MSGREGFILE", "VxH", "GENREG", "MSGREG",
  "ADDRREG", "ACCREG", "FLAGREG", "NOTIFYREG", "STATEREG", "CONTROLREG",
  "IPREG", "PERFORMANCEREG", "THREADREG", "CHANNELENABLEREG", "MASKREG",
  "INTEGER", "LONG", "NULL_TOKEN", "SUBREGNUM", "EMPTYEXECSIZE", "$accept",
  "ROOT", "instrseq", "instruction", "relocatableinstruction",
  "illegalinstruction", "unaryinstruction", "unaryopcodes",
  "binaryinstruction", "binaryopcodes", "binaryaccinstruction",
  "binaryaccopcodes", "mathinstruction", "math_function", "nopinstruction",
  "ternaryinstruction", "ternaryopcodes", "waitinstruction",
  "sendinstruction", "sendop", "sendopcode", "sharedfunction", "exp2",
  "jumpinstruction", "branchinstruction", "breakinstruction",
  "loopinstruction", "relativelocation2", "simple_int", "rellocation",
  "relativelocation", "jumplabel", "jumplabeltarget", "dst", "dstoperand",
  "dstoperandex", "dstoperandex_typed", "dstreg", "srcaccimm", "immreg",
  "reg32", "payload", "src", "srcacc", "srcimm", "directsrcaccoperand",
  "srcarcoperandex", "srcarcoperandex_typed", "indirectsrcoperand",
  "directgenreg_list", "directsrcoperand", "addrparam", "exp", "subregnum",
  "directgenreg", "indirectgenreg", "directmsgreg", "indirectmsgreg",
  "addrreg", "accreg", "flagreg", "maskreg", "notifyreg", "statereg",
  "controlreg", "ipreg", "nullreg", "threadcontrolreg", "performancereg",
  "channelenablereg", "immval", "dstregion", "indirectregion", "region",
  "region_wh", "reg_type", "imm_type", "writemask", "writemask_x",
  "writemask_y", "writemask_z", "writemask_w", "swizzle", "chansel",
  "predicate", "predstate", "predctrl", "negate", "abs", "cond_mod",
  "condModifiers", "msgdesc", "msgdesc_parts", "saturate", "execsize",
  "instoptions", "instoption_list", "instoption", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-478)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      16,   122,  -478,    22,    22,    22,  -478,    22,    37,   427,
      43,   112,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,   467,  -478,  -478,   -91,
       5,   138,     0,   138,   468,  -478,   134,   143,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
      22,  -478,  -478,  -478,    22,  -478,  -478,  -478,  -478,  -478,
    -478,    22,  -478,  -478,  -478,  -478,  -478,    22,    22,    22,
      22,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,    22,  -478,   -23,   -23,   -23,   -23,
     -23,  -478,    22,   157,   238,   -43,  -478,   168,  -478,  -478,
     -82,   148,  -478,  -478,  -478,    12,  -478,   171,   172,   157,
     157,   157,   157,   157,   157,   157,  -478,   157,   157,   157,
     157,  -478,   138,  -478,  -478,   181,   181,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,   181,
    -478,  -478,  -478,  -478,  -478,     2,     8,    10,   156,    36,
      38,     6,    42,  -478,   580,   463,   463,   463,   463,   441,
     -68,  -478,  -139,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,   185,  -478,  -478,   278,  -478,
    -478,  -478,   138,   138,  -478,   -14,   -14,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,   -68,
     183,   183,   183,   165,    12,   170,    12,   138,   138,   173,
     148,    12,   138,   138,     5,  -478,   138,  -478,  -478,   195,
     690,   138,   138,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,    22,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
      22,   214,    22,    22,    22,  -478,  -478,   150,   468,  -478,
    -478,  -478,  -478,  -478,  -478,   440,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,   213,   -68,   227,
     248,    61,   705,   705,   705,   138,   138,   138,   138,  -478,
    -478,   138,   138,   138,  -478,  -478,   262,  -478,  -124,   705,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,   468,
     468,   -91,   468,   468,   468,  -478,   177,  -478,   195,  -478,
    -478,  -478,  -478,  -478,  -478,   195,  -478,  -478,   265,   150,
    -478,  -478,  -478,  -478,  -478,  -478,    66,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,     5,   266,    78,
    -478,   150,    -3,  -478,    -3,   150,    -3,   -43,   452,     5,
     705,   705,  -478,   -62,     5,  -478,    68,   270,   -68,   -68,
    -478,   -68,    -3,  -478,  -478,   265,   138,  -478,  -478,  -478,
    -478,  -478,   265,  -478,    -3,  -478,  -478,    -3,   150,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,   128,   452,  -478,  -478,   195,
    -478,  -478,  -478,  -478,  -478,   452,  -478,    72,     5,   274,
     275,   277,   138,   276,  -478,   -36,   138,   138,    -3,    23,
     138,   128,   283,   128,  -478,  -478,   288,   -68,   -68,   -68,
    -478,   287,   195,  -478,  -478,   138,    23,   279,    23,    23,
     145,  -478,   138,    44,   705,   138,     5,   290,   291,   293,
    -124,   283,  -478,  -478,   705,  -478,  -478,    80,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,    44,  -478,  -478,   292,
    -478,  -478,  -478,    88,   705,  -478,    23,    44,  -478,   -68,
    -478,  -478,    44,   106,  -478,  -478
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
     261,   263,   142,   309,   309,   309,    82,   309,     0,   261,
       0,     0,    17,     9,    10,    11,    12,    13,    15,    14,
      16,    18,    19,    20,    21,     8,     0,   264,   265,     0,
       0,   311,     0,   311,     0,     1,     0,     0,     7,     5,
       6,    55,    40,    56,    57,    58,    85,    41,    86,    24,
     309,    25,    59,    60,   309,    84,    26,    42,    43,    44,
      45,   309,    27,    28,    29,    30,    31,   309,   309,   309,
     309,    46,    87,    32,    47,    48,    88,    33,    49,    34,
      61,    50,    35,    36,    37,    38,    51,    52,    62,    63,
      64,    53,    93,    94,   309,    65,   307,   307,   307,   307,
     307,    95,   309,   199,   266,     0,   112,     0,   315,   130,
       0,   141,   133,   135,   139,   138,    22,     0,     0,   199,
     199,   199,   199,   199,   199,   199,   211,   199,   199,   199,
     199,   212,   311,   143,   144,   218,   218,   159,   160,   161,
     162,   150,   149,   153,   155,   156,   158,   152,   154,   218,
     148,   157,   151,     3,     4,     0,     0,     0,     0,     0,
       0,     0,     0,   308,     0,   289,   289,   289,   289,     0,
       0,   206,     0,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   113,   310,     0,   134,
     136,   140,   311,   311,   137,     0,     0,   200,   202,   204,
     205,   208,   209,   210,   214,   213,   215,   207,    89,     0,
     244,   244,   244,     0,     0,     0,     0,   311,   311,     0,
     141,   138,   311,   311,     0,   216,   311,   131,   132,   222,
       0,   311,   311,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    81,    80,   309,   291,
     294,   295,   296,   297,   293,   292,   298,   300,   290,   299,
     309,   287,   309,   309,   309,   196,   197,   283,     0,   198,
     267,   268,   269,   270,   262,     0,   312,   316,   317,   318,
     330,   320,   321,   319,   331,   322,   323,   324,   326,   325,
     328,   327,   329,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   314,   117,   118,     0,   195,     0,
       0,   246,     0,     0,     0,   311,   311,   311,   311,   115,
     116,   311,   311,   311,   121,   122,     0,   114,     0,     0,
     234,   233,   232,   231,   230,   229,   237,   236,   241,   243,
     228,   238,   235,   239,   242,   240,   165,   128,   129,     0,
       0,     0,     0,     0,     0,   284,   283,   193,   222,   167,
     182,   184,   185,   181,   183,   222,   179,   180,   285,   283,
     313,   201,   194,   203,   219,   247,   248,   146,   145,   147,
     123,   124,   126,   127,   125,   119,   120,     0,     0,     0,
     166,   283,   283,   288,   283,   283,   283,   284,     0,     0,
       0,     0,   286,     0,     0,   249,   250,     0,     0,     0,
     223,     0,   283,   169,   168,   285,   311,   164,   163,   170,
     171,   175,   285,   174,   283,   173,   172,   283,   283,   105,
     109,   106,   108,    98,    97,   107,    99,   104,   110,   102,
     101,   103,   100,   111,    96,     0,     0,   177,   178,   222,
     187,   188,   190,   189,   191,     0,   251,   252,     0,     0,
       0,     0,   311,     0,    23,     0,   311,   311,   283,   306,
     311,     0,   254,     0,   253,   245,     0,     0,     0,     0,
      66,   222,   222,    39,    54,   311,   306,     0,   306,   306,
       0,    90,   311,     0,     0,   311,     0,     0,     0,     0,
       0,   254,   220,   221,     0,    83,   305,     0,   303,   304,
     301,    92,   257,   258,   259,   260,   255,   192,    91,     0,
     226,   224,   225,     0,     0,   176,   306,     0,   217,     0,
     186,   302,     0,     0,   256,   227
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -478,  -478,  -478,   295,   302,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -352,   -30,  -478,  -478,  -478,  -478,  -478,  -478,    92,
     249,    97,   309,  -144,  -478,  -478,  -478,  -478,  -478,  -155,
    -478,  -324,  -109,   -75,  -343,  -478,  -478,  -478,  -283,  -478,
    -259,   125,  -169,   619,  -158,  -347,  -392,  -478,  -191,  -143,
     -17,   -25,  -383,   -11,    -5,     1,     9,    27,  -373,    34,
    -478,   -87,  -478,  -351,  -478,  -266,  -478,   -44,  -478,  -478,
    -478,  -478,  -178,  -477,  -478,  -478,  -478,  -252,  -384,   -79,
    -478,  -345,  -411,   155,    52,   -31,  -478,    55
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     8,     9,    10,    11,    12,    13,    97,    14,    98,
      15,    99,    16,   248,    17,    18,   100,    19,    20,   101,
     102,   445,   225,    21,    22,    23,    24,   226,   114,   193,
     194,   192,    25,   132,   133,   134,   135,   136,   416,   423,
     228,   356,   412,   418,   424,   419,   357,   358,   425,   449,
     426,   307,   268,   171,   137,   138,   139,   140,   141,   142,
     360,   361,   145,   362,   363,   364,   365,   366,   151,   367,
     230,   210,   501,   329,   503,   345,   346,   312,   376,   406,
     457,   475,   494,   516,    26,    29,   185,   415,   403,   260,
     261,   470,   490,   164,    31,   109,   188,   304
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     107,   269,   116,   229,   308,   308,   227,   400,   359,   144,
     224,   451,   104,   397,   401,   368,   110,   143,   110,   224,
     453,   105,   105,   146,   110,   267,   110,     1,   110,   147,
     454,   463,   399,    30,   111,   148,   213,    35,   465,   527,
     310,   486,   215,   149,   217,   404,   377,   378,   379,   211,
     532,     2,   110,   428,   110,   534,    32,    33,   110,    34,
      39,   150,   212,   390,   270,   271,   272,   273,   152,   462,
     220,   451,   222,   451,     3,   506,   231,   508,   509,     4,
     453,   466,   453,   409,   467,   388,   410,   262,   263,   264,
     454,     5,   454,   529,   471,   411,   410,   359,   472,   265,
     266,   208,   155,   473,   368,   411,   156,     6,   413,   420,
     359,   478,   420,   157,   535,   531,   481,   368,   481,   158,
     159,   160,   161,   103,   369,   485,   492,     7,   495,    40,
     502,   504,   414,   421,   447,   448,   421,    27,    28,   372,
     422,   189,   190,   422,   144,   413,   162,   108,   119,   120,
     121,   153,   143,   123,   169,   265,   266,   127,   146,   389,
     154,   305,   306,   170,   147,   163,   355,   313,   314,   414,
     148,   117,   487,   488,   119,   120,   121,   122,   149,   123,
     187,   186,   191,   127,   195,   196,   319,   320,   209,   311,
     219,   324,   325,   397,   326,   327,   150,   274,   121,   315,
     347,   348,   328,   152,   317,   391,   392,   321,   394,   395,
     396,   103,   452,   124,   125,   126,   119,   128,   129,   130,
     351,   106,   131,   112,   113,   112,   113,   371,   517,   106,
     106,   112,   113,   112,   113,   112,   113,   417,   525,   459,
     460,   373,   461,   144,   172,   450,   489,   512,   513,   514,
     515,   143,   165,   166,   167,   168,   374,   146,   530,   112,
     113,   112,   113,   147,   375,   112,   113,   387,   402,   148,
     405,   408,   452,   456,   452,   458,   469,   149,   474,   477,
     478,   115,   479,   275,   380,   381,   382,   383,   276,   493,
     384,   385,   386,   496,   500,   150,   510,   507,   520,   521,
     349,   522,   152,   526,    36,   450,   528,   450,   497,   498,
     499,    37,   350,   323,   352,   353,   354,   322,    38,   468,
     427,   309,   482,   524,   144,   144,   398,   144,   144,   144,
     370,   523,   143,   143,   393,   143,   143,   143,   146,   146,
       0,   146,   146,   146,   147,   147,     0,   147,   147,   147,
     148,   148,     0,   148,   148,   148,     0,   407,   149,   149,
     533,   149,   149,   149,   103,     0,   124,   125,   126,   446,
     128,   129,   130,     0,   455,   131,   150,   150,     0,   150,
     150,   150,     0,   152,   152,   464,   152,   152,   152,     0,
       0,   103,     0,   124,   125,   126,     0,   128,   129,   130,
       0,   106,   131,     0,   214,   216,   218,     0,   221,   223,
       0,   232,     0,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,     0,     0,    -2,   476,     0,
       0,   480,     0,     0,     0,   483,   484,     0,     1,   491,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   505,     0,     0,     0,     0,     0,
       0,   511,     2,   316,   518,   318,   519,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,     0,     0,   117,     0,     3,   119,   120,   121,     0,
       4,   123,     0,     0,     0,   127,     0,     0,     0,     0,
       0,     0,     5,    41,    42,    43,    44,    45,    46,    47,
      48,     0,    49,     0,     0,    50,     0,     0,     6,    51,
      52,    53,    54,    55,    56,     0,    57,    58,    59,    60,
       0,    61,    62,    63,    64,    65,     0,    66,     7,    67,
      68,    69,     0,    70,     0,    71,    72,    73,    74,    75,
      76,     0,    77,     0,    78,     0,     0,     0,     0,    79,
      80,    81,     0,     0,     0,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     0,    91,    92,    93,     0,    94,
      95,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,     0,     0,     0,
       0,    96,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,     0,     0,     0,     0,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,     0,     0,     0,     0,     0,   117,   118,
     259,   119,   120,   121,   122,   103,   123,   124,   125,   126,
     127,   128,   129,   130,   265,   266,   131,     0,     0,     0,
       0,     0,     0,     0,     0,   117,   118,   444,   119,   120,
     121,   122,   103,   123,   124,   125,   126,   127,   128,   129,
     130,     0,     0,   131,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   330,   331,   332,   333,   334,   335,
     336,   337,     0,     0,   340,   341,   342,   343,   197,   198,
     199,   200,   201,   202,   203,     0,   204,   205,   206,   207
};

static const yytype_int16 yycheck[] =
{
      30,   170,    33,   161,   195,   196,   161,   358,   267,    34,
      13,   403,    29,    16,   365,   267,    16,    34,    16,    13,
     403,    16,    16,    34,    16,   169,    16,    11,    16,    34,
     403,   415,   356,    11,    34,    34,    34,     0,   422,   516,
     209,    18,    34,    34,    34,   369,   312,   313,   314,   136,
     527,    35,    16,   396,    16,   532,     4,     5,    16,     7,
      17,    34,   149,   329,   203,   204,   205,   206,    34,   412,
      34,   463,    34,   465,    58,   486,    34,   488,   489,    63,
     463,   424,   465,     5,   427,   209,     8,   166,   167,   168,
     463,    75,   465,     5,   446,    17,     8,   356,   449,   223,
     224,   132,    50,   455,   356,    17,    54,    91,   391,   392,
     369,     5,   395,    61,     8,   526,   463,   369,   465,    67,
      68,    69,    70,   214,   268,   468,   471,   111,   473,    17,
     481,   482,   391,   392,   400,   401,   395,    15,    16,   308,
     392,   223,   224,   395,   169,   428,    94,     9,   210,   211,
     212,    17,   169,   215,   102,   223,   224,   219,   169,   328,
      17,   192,   193,     6,   169,   188,    16,   211,   212,   428,
     169,   207,   149,   150,   210,   211,   212,   213,   169,   215,
      12,   224,    34,   219,    13,    13,   217,   218,     7,     6,
      34,   222,   223,    16,   224,   226,   169,    12,   212,    34,
     231,   232,     7,   169,    34,   349,   350,    34,   352,   353,
     354,   214,   403,   216,   217,   218,   210,   220,   221,   222,
       6,   224,   225,   223,   224,   223,   224,    14,   494,   224,
     224,   223,   224,   223,   224,   223,   224,   392,   504,   408,
     409,    14,   411,   268,     6,   403,   223,   203,   204,   205,
     206,   268,    97,    98,    99,   100,     8,   268,   524,   223,
     224,   223,   224,   268,   203,   223,   224,     5,     3,   268,
     204,     5,   463,   205,   465,     5,   148,   268,   206,     5,
       5,    32,     5,     5,   315,   316,   317,   318,    10,     6,
     321,   322,   323,     5,     7,   268,   151,    18,     8,     8,
     248,     8,   268,   223,     9,   463,    14,   465,   477,   478,
     479,     9,   260,   221,   262,   263,   264,   220,     9,   428,
     395,   196,   465,   501,   349,   350,   356,   352,   353,   354,
     275,   500,   349,   350,   351,   352,   353,   354,   349,   350,
      -1,   352,   353,   354,   349,   350,    -1,   352,   353,   354,
     349,   350,    -1,   352,   353,   354,    -1,   387,   349,   350,
     529,   352,   353,   354,   214,    -1,   216,   217,   218,   399,
     220,   221,   222,    -1,   404,   225,   349,   350,    -1,   352,
     353,   354,    -1,   349,   350,   416,   352,   353,   354,    -1,
      -1,   214,    -1,   216,   217,   218,    -1,   220,   221,   222,
      -1,   224,   225,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,    -1,     0,   458,    -1,
      -1,   462,    -1,    -1,    -1,   466,   467,    -1,    11,   470,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,    -1,   485,    -1,    -1,    -1,    -1,    -1,
      -1,   492,    35,   214,   495,   216,   496,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,    -1,   207,    -1,    58,   210,   211,   212,    -1,
      63,   215,    -1,    -1,    -1,   219,    -1,    -1,    -1,    -1,
      -1,    -1,    75,    36,    37,    38,    39,    40,    41,    42,
      43,    -1,    45,    -1,    -1,    48,    -1,    -1,    91,    52,
      53,    54,    55,    56,    57,    -1,    59,    60,    61,    62,
      -1,    64,    65,    66,    67,    68,    -1,    70,   111,    72,
      73,    74,    -1,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    -1,    87,    -1,    -1,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,    -1,   108,   109,   110,    -1,   112,
     113,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,    -1,    -1,    -1,    -1,
      -1,   134,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,    -1,    -1,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,    -1,    -1,    -1,    -1,   207,   208,
     187,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   207,   208,   225,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,    -1,   225,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    19,    20,    21,    22,    23,    24,
      25,    26,    -1,    -1,    29,    30,    31,    32,   119,   120,
     121,   122,   123,   124,   125,    -1,   127,   128,   129,   130
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    11,    35,    58,    63,    75,    91,   111,   229,   230,
     231,   232,   233,   234,   236,   238,   240,   242,   243,   245,
     246,   251,   252,   253,   254,   260,   312,    15,    16,   313,
      11,   322,   322,   322,   322,     0,   231,   232,   260,    17,
      17,    36,    37,    38,    39,    40,    41,    42,    43,    45,
      48,    52,    53,    54,    55,    56,    57,    59,    60,    61,
      62,    64,    65,    66,    67,    68,    70,    72,    73,    74,
      76,    78,    79,    80,    81,    82,    83,    85,    87,    92,
      93,    94,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   108,   109,   110,   112,   113,   134,   235,   237,   239,
     244,   247,   248,   214,   288,    16,   224,   250,     9,   323,
      16,    34,   223,   224,   256,   258,   323,   207,   208,   210,
     211,   212,   213,   215,   216,   217,   218,   219,   220,   221,
     222,   225,   261,   262,   263,   264,   265,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    17,    17,   322,   322,   322,   322,   322,
     322,   322,   322,   188,   321,   321,   321,   321,   321,   322,
       6,   281,     6,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   314,   224,    12,   324,   223,
     224,    34,   259,   257,   258,    13,    13,   281,   281,   281,
     281,   281,   281,   281,   281,   281,   281,   281,   323,     7,
     299,   299,   299,    34,   258,    34,   258,    34,   258,    34,
      34,   258,    34,   258,    13,   250,   255,   267,   268,   282,
     298,    34,   258,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   241,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   187,
     317,   318,   317,   317,   317,   223,   224,   261,   280,   280,
     203,   204,   205,   206,    12,     5,    10,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   325,   323,   323,   279,   286,   279,
     280,     6,   305,   305,   305,    34,   258,    34,   258,   323,
     323,    34,   259,   257,   323,   323,   250,   323,     7,   301,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,   303,   304,   323,   323,   322,
     322,     6,   322,   322,   322,    16,   269,   274,   275,   278,
     288,   289,   291,   292,   293,   294,   295,   297,   315,   261,
     325,    14,   280,    14,     8,   203,   306,   303,   303,   303,
     323,   323,   323,   323,   323,   323,   323,     5,   209,   280,
     303,   261,   261,   288,   261,   261,   261,    16,   250,   269,
     301,   301,     3,   316,   269,   204,   307,   250,     5,     5,
       8,    17,   270,   276,   278,   315,   266,   267,   271,   273,
     276,   278,   315,   267,   272,   276,   278,   271,   272,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   225,   249,   250,   303,   303,   277,
     282,   284,   286,   290,   296,   250,   205,   308,     5,   280,
     280,   280,   272,   316,   323,   316,   272,   272,   270,   148,
     319,   249,   301,   249,   206,   309,   250,     5,     5,     5,
     323,   283,   287,   323,   323,   272,    18,   149,   150,   223,
     320,   323,   319,     6,   310,   319,     5,   280,   280,   280,
       7,   300,   301,   302,   301,   323,   320,    18,   320,   320,
     151,   323,   203,   204,   205,   206,   311,   303,   323,   250,
       8,     8,     8,   280,   310,   303,   223,   311,    14,     5,
     303,   320,   311,   280,   311,     8
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   228,   229,   230,   230,   230,   230,   230,   230,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   232,   232,
     232,   232,   233,   234,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   236,
     237,   237,   237,   237,   237,   237,   237,   237,   237,   237,
     237,   237,   237,   237,   238,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   240,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   242,   243,   244,   244,   244,   244,   244,   245,
     246,   246,   246,   247,   247,   248,   249,   249,   249,   249,
     249,   249,   249,   249,   249,   249,   249,   249,   249,   249,
     249,   249,   250,   250,   251,   252,   252,   252,   252,   252,
     252,   252,   252,   253,   253,   253,   253,   253,   254,   254,
     254,   255,   255,   256,   256,   256,   256,   257,   257,   258,
     259,   259,   260,   261,   261,   262,   263,   263,   263,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   265,
     265,   265,   265,   266,   266,   267,   268,   269,   270,   270,
     271,   271,   272,   272,   272,   273,   273,   274,   274,   274,
     275,   275,   275,   275,   275,   275,   276,   277,   277,   277,
     277,   277,   278,   278,   279,   279,   280,   280,   281,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   298,   299,   299,
     300,   300,   301,   301,   301,   301,   301,   302,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     304,   304,   304,   304,   305,   305,   306,   306,   307,   307,
     308,   308,   309,   309,   310,   310,   310,   311,   311,   311,
     311,   312,   312,   313,   313,   313,   314,   314,   314,   314,
     314,   314,   314,   314,   314,   314,   314,   314,   314,   314,
     314,   314,   314,   315,   315,   316,   316,   317,   317,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   318,   318,
     318,   319,   320,   320,   320,   320,   320,   321,   321,   322,
     322,   323,   323,   324,   324,   324,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     3,     3,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     8,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     9,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     9,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     9,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,    10,     1,     1,     1,     1,     1,     4,
       9,    10,    10,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     5,     5,     5,     5,     5,     6,
       6,     5,     5,     6,     6,     6,     6,     6,     5,     5,
       3,     1,     1,     1,     2,     1,     2,     1,     0,     1,
       1,     0,     1,     1,     1,     4,     4,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     6,     1,     1,     1,
       1,     1,     6,     1,     2,     1,     1,     1,     2,     0,
       2,     4,     2,     4,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     2,     2,     2,     1,     9,     0,     3,
       1,     1,     0,     3,     7,     7,     7,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     5,     0,     1,     0,     1,
       0,     1,     0,     1,     0,     2,     5,     1,     1,     1,
       1,     0,     5,     0,     1,     1,     0,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     0,     1,     1,     3,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     4,     2,     2,     2,     0,     0,     1,     0,
       3,     0,     3,     3,     2,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 22: /* illegalinstruction: ILLEGAL execsize instoptions  */
#line 688 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-2].integer));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-1].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
	}
#line 2435 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 23: /* unaryinstruction: predicate unaryopcodes saturate cond_mod execsize dst srcaccimm instoptions  */
#line 698 "../src/intel/compiler/elk/elk_gram.y"
        {
		i965_asm_set_dst_nr(p, &(yyvsp[-2].reg), (yyvsp[0].options));
		elk_set_default_access_mode(p, (yyvsp[0].options).access_mode);
		i965_asm_unary_instruction((yyvsp[-6].integer), p, (yyvsp[-2].reg), (yyvsp[-1].reg));
		elk_pop_insn_state(p);
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_cond_modifier(p->devinfo, elk_last_inst,
					   (yyvsp[-4].condition).cond_modifier);

		if (p->devinfo->ver >= 7 && (yyvsp[-6].integer) != ELK_OPCODE_DIM &&
		    !elk_inst_flag_reg_nr(p->devinfo, elk_last_inst)) {
			elk_inst_set_flag_reg_nr(p->devinfo,
						 elk_last_inst,
						 (yyvsp[-4].condition).flag_reg_nr);
			elk_inst_set_flag_subreg_nr(p->devinfo,
						    elk_last_inst,
						    (yyvsp[-4].condition).flag_subreg_nr);
		}

		if ((yyvsp[-1].reg).file != ELK_IMMEDIATE_VALUE) {
			elk_inst_set_src0_vstride(p->devinfo, elk_last_inst,
						  (yyvsp[-1].reg).vstride);
		}
		elk_inst_set_saturate(p->devinfo, elk_last_inst, (yyvsp[-5].integer));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));
		// TODO: set instruction group instead of qtr and nib ctrl
		elk_inst_set_qtr_control(p->devinfo, elk_last_inst,
				         (yyvsp[0].options).qtr_ctrl);

		if (p->devinfo->ver >= 7)
			elk_inst_set_nib_control(p->devinfo, elk_last_inst,
					         (yyvsp[0].options).nib_ctrl);
	}
#line 2473 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 39: /* binaryinstruction: predicate binaryopcodes saturate cond_mod execsize dst srcimm srcimm instoptions  */
#line 754 "../src/intel/compiler/elk/elk_gram.y"
        {
		i965_asm_set_dst_nr(p, &(yyvsp[-3].reg), (yyvsp[0].options));
		elk_set_default_access_mode(p, (yyvsp[0].options).access_mode);
		i965_asm_binary_instruction((yyvsp[-7].integer), p, (yyvsp[-3].reg), (yyvsp[-2].reg), (yyvsp[-1].reg));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_cond_modifier(p->devinfo, elk_last_inst,
					   (yyvsp[-5].condition).cond_modifier);

		if (p->devinfo->ver >= 7 &&
		    !elk_inst_flag_reg_nr(p->devinfo, elk_last_inst)) {
			elk_inst_set_flag_reg_nr(p->devinfo, elk_last_inst,
					         (yyvsp[-5].condition).flag_reg_nr);
			elk_inst_set_flag_subreg_nr(p->devinfo, elk_last_inst,
						    (yyvsp[-5].condition).flag_subreg_nr);
		}

		elk_inst_set_saturate(p->devinfo, elk_last_inst, (yyvsp[-6].integer));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-4].integer));
		// TODO: set instruction group instead of qtr and nib ctrl
		elk_inst_set_qtr_control(p->devinfo, elk_last_inst,
				         (yyvsp[0].options).qtr_ctrl);

		if (p->devinfo->ver >= 7)
			elk_inst_set_nib_control(p->devinfo, elk_last_inst,
					         (yyvsp[0].options).nib_ctrl);

		elk_pop_insn_state(p);
	}
#line 2506 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 54: /* binaryaccinstruction: predicate binaryaccopcodes saturate cond_mod execsize dst srcacc srcimm instoptions  */
#line 804 "../src/intel/compiler/elk/elk_gram.y"
        {
		i965_asm_set_dst_nr(p, &(yyvsp[-3].reg), (yyvsp[0].options));
		elk_set_default_access_mode(p, (yyvsp[0].options).access_mode);
		i965_asm_binary_instruction((yyvsp[-7].integer), p, (yyvsp[-3].reg), (yyvsp[-2].reg), (yyvsp[-1].reg));
		elk_pop_insn_state(p);
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_cond_modifier(p->devinfo, elk_last_inst,
					   (yyvsp[-5].condition).cond_modifier);

		if (p->devinfo->ver >= 7 &&
		    !elk_inst_flag_reg_nr(p->devinfo, elk_last_inst)) {
			elk_inst_set_flag_reg_nr(p->devinfo,
						 elk_last_inst,
						 (yyvsp[-5].condition).flag_reg_nr);
			elk_inst_set_flag_subreg_nr(p->devinfo,
						    elk_last_inst,
						    (yyvsp[-5].condition).flag_subreg_nr);
		}

		elk_inst_set_saturate(p->devinfo, elk_last_inst, (yyvsp[-6].integer));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-4].integer));
		// TODO: set instruction group instead of qtr and nib ctrl
		elk_inst_set_qtr_control(p->devinfo, elk_last_inst,
				         (yyvsp[0].options).qtr_ctrl);

		if (p->devinfo->ver >= 7)
			elk_inst_set_nib_control(p->devinfo, elk_last_inst,
					         (yyvsp[0].options).nib_ctrl);
	}
#line 2540 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 66: /* mathinstruction: predicate MATH saturate math_function execsize dst src srcimm instoptions  */
#line 852 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_set_default_access_mode(p, (yyvsp[0].options).access_mode);
		elk_gfx6_math(p, (yyvsp[-3].reg), (yyvsp[-5].integer), (yyvsp[-2].reg), (yyvsp[-1].reg));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-4].integer));
		elk_inst_set_saturate(p->devinfo, elk_last_inst, (yyvsp[-6].integer));
		// TODO: set instruction group instead
		elk_inst_set_qtr_control(p->devinfo, elk_last_inst,
				         (yyvsp[0].options).qtr_ctrl);

		if (p->devinfo->ver >= 7)
			elk_inst_set_nib_control(p->devinfo, elk_last_inst,
					         (yyvsp[0].options).nib_ctrl);

		elk_pop_insn_state(p);
	}
#line 2561 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 82: /* nopinstruction: NOP  */
#line 891 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_NOP(p);
	}
#line 2569 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 83: /* ternaryinstruction: predicate ternaryopcodes saturate cond_mod execsize dst srcimm src srcimm instoptions  */
#line 899 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_set_default_access_mode(p, (yyvsp[0].options).access_mode);
		i965_asm_ternary_instruction((yyvsp[-8].integer), p, (yyvsp[-4].reg), (yyvsp[-3].reg), (yyvsp[-2].reg), (yyvsp[-1].reg));
		elk_pop_insn_state(p);
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_cond_modifier(p->devinfo, elk_last_inst,
					   (yyvsp[-6].condition).cond_modifier);

		if (p->devinfo->ver >= 7) {
			elk_inst_set_3src_a16_flag_reg_nr(p->devinfo, elk_last_inst,
					         (yyvsp[-6].condition).flag_reg_nr);
			elk_inst_set_3src_a16_flag_subreg_nr(p->devinfo, elk_last_inst,
						    (yyvsp[-6].condition).flag_subreg_nr);
		}

		elk_inst_set_saturate(p->devinfo, elk_last_inst, (yyvsp[-7].integer));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-5].integer));
		// TODO: set instruction group instead of qtr and nib ctrl
		elk_inst_set_qtr_control(p->devinfo, elk_last_inst,
				         (yyvsp[0].options).qtr_ctrl);

		if (p->devinfo->ver >= 7)
			elk_inst_set_nib_control(p->devinfo, elk_last_inst,
					         (yyvsp[0].options).nib_ctrl);
	}
#line 2599 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 89: /* waitinstruction: WAIT execsize dst instoptions  */
#line 937 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-3].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_set_default_access_mode(p, (yyvsp[0].options).access_mode);
		struct elk_reg dest = (yyvsp[-1].reg);
		dest.swizzle = elk_swizzle_for_mask(dest.writemask);
		if (dest.file != ARF || dest.nr != ELK_ARF_NOTIFICATION_COUNT)
			error(&(yylsp[-3]), "WAIT must use the notification register\n");
		elk_set_dest(p, elk_last_inst, dest);
		elk_set_src0(p, elk_last_inst, dest);
		elk_set_src1(p, elk_last_inst, elk_null_reg());
		elk_inst_set_mask_control(p->devinfo, elk_last_inst, ELK_MASK_DISABLE);
	}
#line 2618 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 90: /* sendinstruction: predicate sendopcode execsize dst payload exp2 sharedfunction msgdesc instoptions  */
#line 956 "../src/intel/compiler/elk/elk_gram.y"
        {
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-6].integer));
		elk_set_dest(p, elk_last_inst, (yyvsp[-5].reg));
		elk_set_src0(p, elk_last_inst, (yyvsp[-4].reg));
		elk_inst_set_bits(elk_last_inst, 127, 96, (yyvsp[-3].llint));
		elk_inst_set_src1_file_type(p->devinfo, elk_last_inst,
				            ELK_IMMEDIATE_VALUE,
					    ELK_REGISTER_TYPE_UD);
		elk_inst_set_sfid(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_inst_set_eot(p->devinfo, elk_last_inst, (yyvsp[0].options).end_of_thread);
		// TODO: set instruction group instead of qtr and nib ctrl
		elk_inst_set_qtr_control(p->devinfo, elk_last_inst,
				         (yyvsp[0].options).qtr_ctrl);

		if (p->devinfo->ver >= 7)
			elk_inst_set_nib_control(p->devinfo, elk_last_inst,
					         (yyvsp[0].options).nib_ctrl);

		elk_pop_insn_state(p);
	}
#line 2644 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 91: /* sendinstruction: predicate sendopcode execsize exp dst payload exp2 sharedfunction msgdesc instoptions  */
#line 978 "../src/intel/compiler/elk/elk_gram.y"
        {
		assert(p->devinfo->ver < 6);

		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-7].integer));
		elk_inst_set_base_mrf(p->devinfo, elk_last_inst, (yyvsp[-6].integer));
		elk_set_dest(p, elk_last_inst, (yyvsp[-5].reg));
		elk_set_src0(p, elk_last_inst, (yyvsp[-4].reg));
		elk_inst_set_bits(elk_last_inst, 127, 96, (yyvsp[-3].llint));
		elk_inst_set_src1_file_type(p->devinfo, elk_last_inst,
				            ELK_IMMEDIATE_VALUE,
					    ELK_REGISTER_TYPE_UD);
		elk_inst_set_sfid(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_inst_set_eot(p->devinfo, elk_last_inst, (yyvsp[0].options).end_of_thread);
		// TODO: set instruction group instead of qtr and nib ctrl
		elk_inst_set_qtr_control(p->devinfo, elk_last_inst,
				         (yyvsp[0].options).qtr_ctrl);

		elk_pop_insn_state(p);
	}
#line 2669 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 92: /* sendinstruction: predicate sendopcode execsize dst payload payload exp2 sharedfunction msgdesc instoptions  */
#line 999 "../src/intel/compiler/elk/elk_gram.y"
        {
		assert(p->devinfo->ver >= 6);

		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-7].integer));
		elk_set_dest(p, elk_last_inst, (yyvsp[-6].reg));
		elk_set_src0(p, elk_last_inst, (yyvsp[-5].reg));
		elk_inst_set_bits(elk_last_inst, 127, 96, (yyvsp[-3].llint));
		elk_inst_set_sfid(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_inst_set_eot(p->devinfo, elk_last_inst, (yyvsp[0].options).end_of_thread);
		// TODO: set instruction group instead of qtr and nib ctrl
		elk_inst_set_qtr_control(p->devinfo, elk_last_inst,
				         (yyvsp[0].options).qtr_ctrl);

		if (p->devinfo->ver >= 7)
			elk_inst_set_nib_control(p->devinfo, elk_last_inst,
					         (yyvsp[0].options).nib_ctrl);

		elk_pop_insn_state(p);
	}
#line 2694 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 95: /* sendopcode: sendop  */
#line 1027 "../src/intel/compiler/elk/elk_gram.y"
                 { (yyval.instruction) = elk_next_insn(p, (yyvsp[0].integer)); }
#line 2700 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 96: /* sharedfunction: NULL_TOKEN  */
#line 1031 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_NULL; }
#line 2706 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 97: /* sharedfunction: MATH  */
#line 1032 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_MATH; }
#line 2712 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 98: /* sharedfunction: GATEWAY  */
#line 1033 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_MESSAGE_GATEWAY; }
#line 2718 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 99: /* sharedfunction: READ  */
#line 1034 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_DATAPORT_READ; }
#line 2724 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 100: /* sharedfunction: WRITE  */
#line 1035 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_DATAPORT_WRITE; }
#line 2730 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 101: /* sharedfunction: URB  */
#line 1036 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_URB; }
#line 2736 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 102: /* sharedfunction: THREAD_SPAWNER  */
#line 1037 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_THREAD_SPAWNER; }
#line 2742 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 103: /* sharedfunction: VME  */
#line 1038 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_VME; }
#line 2748 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 104: /* sharedfunction: RENDER  */
#line 1039 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = GFX6_SFID_DATAPORT_RENDER_CACHE; }
#line 2754 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 105: /* sharedfunction: CONST  */
#line 1040 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = GFX6_SFID_DATAPORT_CONSTANT_CACHE; }
#line 2760 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 106: /* sharedfunction: DATA  */
#line 1041 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = GFX7_SFID_DATAPORT_DATA_CACHE; }
#line 2766 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 107: /* sharedfunction: PIXEL_INTERP  */
#line 1042 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = GFX7_SFID_PIXEL_INTERPOLATOR; }
#line 2772 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 108: /* sharedfunction: DP_DATA_1  */
#line 1043 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = HSW_SFID_DATAPORT_DATA_CACHE_1; }
#line 2778 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 109: /* sharedfunction: CRE  */
#line 1044 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = HSW_SFID_CRE; }
#line 2784 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 110: /* sharedfunction: SAMPLER  */
#line 1045 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = ELK_SFID_SAMPLER; }
#line 2790 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 111: /* sharedfunction: DP_SAMPLER  */
#line 1046 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = GFX6_SFID_DATAPORT_SAMPLER_CACHE; }
#line 2796 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 112: /* exp2: LONG  */
#line 1050 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.llint) = (yyvsp[0].llint); }
#line 2802 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 113: /* exp2: MINUS LONG  */
#line 1051 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.llint) = -(yyvsp[0].llint); }
#line 2808 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 114: /* jumpinstruction: predicate JMPI execsize relativelocation2 instoptions  */
#line 1057 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-3].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_set_dest(p, elk_last_inst, elk_ip_reg());
		elk_set_src0(p, elk_last_inst, elk_ip_reg());
		elk_set_src1(p, elk_last_inst, (yyvsp[-1].reg));
		elk_inst_set_pred_control(p->devinfo, elk_last_inst,
					  elk_inst_pred_control(p->devinfo,
								elk_last_inst));
		elk_pop_insn_state(p);
	}
#line 2825 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 115: /* branchinstruction: predicate ENDIF execsize JUMP_LABEL instoptions  */
#line 1074 "../src/intel/compiler/elk/elk_gram.y"
        {
		add_label(p, (yyvsp[-1].string), INSTR_LABEL_JIP);

		elk_next_insn(p, (yyvsp[-3].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-2].integer));

		if (p->devinfo->ver == 6) {
			elk_set_dest(p, elk_last_inst, elk_imm_w(0x0));
			elk_set_src0(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src1(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
		} else if (p->devinfo->ver == 7) {
			elk_set_dest(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src0(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src1(p, elk_last_inst, elk_imm_w(0x0));
		} else {
			elk_set_src0(p, elk_last_inst, elk_imm_d(0x0));
		}

		elk_pop_insn_state(p);
	}
#line 2855 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 116: /* branchinstruction: predicate ENDIF execsize relativelocation instoptions  */
#line 1100 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-3].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-2].integer));

		elk_set_dest(p, elk_last_inst, retype(elk_null_reg(),
					ELK_REGISTER_TYPE_D));
		elk_set_src0(p, elk_last_inst, retype(elk_null_reg(),
					ELK_REGISTER_TYPE_D));
		elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));
		elk_inst_set_gfx4_pop_count(p->devinfo, elk_last_inst, (yyvsp[-1].integer));

		elk_inst_set_thread_control(p->devinfo, elk_last_inst,
						ELK_THREAD_SWITCH);

		elk_pop_insn_state(p);
	}
#line 2877 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 117: /* branchinstruction: ELSE execsize JUMP_LABEL jumplabel instoptions  */
#line 1118 "../src/intel/compiler/elk/elk_gram.y"
        {
		add_label(p, (yyvsp[-2].string), INSTR_LABEL_JIP);
		add_label(p, (yyvsp[-1].string), INSTR_LABEL_UIP);

		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));

		if (p->devinfo->ver == 6) {
			elk_set_dest(p, elk_last_inst, elk_imm_w(0x0));
			elk_set_src0(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src1(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
		} else if (p->devinfo->ver == 7) {
			elk_set_dest(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src0(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src1(p, elk_last_inst, elk_imm_w(0));
		} else {
			elk_set_dest(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
                        elk_set_src0(p, elk_last_inst, elk_imm_d(0));
		}
	}
#line 2908 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 118: /* branchinstruction: ELSE execsize relativelocation rellocation instoptions  */
#line 1145 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));

		elk_set_dest(p, elk_last_inst, elk_ip_reg());
		elk_set_src0(p, elk_last_inst, elk_ip_reg());
		elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));
		elk_inst_set_gfx4_jump_count(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_inst_set_gfx4_pop_count(p->devinfo, elk_last_inst, (yyvsp[-1].integer));

		if (!p->single_program_flow)
			elk_inst_set_thread_control(p->devinfo, elk_last_inst,
						    ELK_THREAD_SWITCH);
	}
#line 2928 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 119: /* branchinstruction: predicate IF execsize JUMP_LABEL jumplabel instoptions  */
#line 1161 "../src/intel/compiler/elk/elk_gram.y"
        {
		add_label(p, (yyvsp[-2].string), INSTR_LABEL_JIP);
		add_label(p, (yyvsp[-1].string), INSTR_LABEL_UIP);

		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));

		if (p->devinfo->ver == 6) {
			elk_set_dest(p, elk_last_inst, elk_imm_w(0x0));
			elk_set_src0(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
			elk_set_src1(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
		} else if (p->devinfo->ver == 7) {
			elk_set_dest(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
			elk_set_src0(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
			elk_set_src1(p, elk_last_inst, elk_imm_w(0x0));
		} else {
			elk_set_dest(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
			elk_set_src0(p, elk_last_inst, elk_imm_d(0x0));
		}

		elk_pop_insn_state(p);
	}
#line 2966 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 120: /* branchinstruction: predicate IF execsize relativelocation rellocation instoptions  */
#line 1195 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));

		elk_set_dest(p, elk_last_inst, elk_ip_reg());
		elk_set_src0(p, elk_last_inst, elk_ip_reg());
		elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));
		elk_inst_set_gfx4_jump_count(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_inst_set_gfx4_pop_count(p->devinfo, elk_last_inst, (yyvsp[-1].integer));

		if (!p->single_program_flow)
			elk_inst_set_thread_control(p->devinfo, elk_last_inst,
						    ELK_THREAD_SWITCH);

		elk_pop_insn_state(p);
	}
#line 2988 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 121: /* branchinstruction: predicate IFF execsize JUMP_LABEL instoptions  */
#line 1213 "../src/intel/compiler/elk/elk_gram.y"
        {
		add_label(p, (yyvsp[-1].string), INSTR_LABEL_JIP);

		elk_next_insn(p, (yyvsp[-3].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-2].integer));

		if (p->devinfo->ver == 6) {
			elk_set_src0(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
			elk_set_src1(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
		} else if (p->devinfo->ver == 7) {
			elk_set_dest(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
			elk_set_src0(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
			elk_set_src1(p, elk_last_inst, elk_imm_w(0x0));
		} else {
			elk_set_dest(p, elk_last_inst,
				     vec1(retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D)));
			elk_set_src0(p, elk_last_inst, elk_imm_d(0x0));
		}

		elk_pop_insn_state(p);
	}
#line 3024 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 122: /* branchinstruction: predicate IFF execsize relativelocation instoptions  */
#line 1245 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-3].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-2].integer));

		elk_set_dest(p, elk_last_inst, elk_ip_reg());
		elk_set_src0(p, elk_last_inst, elk_ip_reg());
		elk_inst_set_gfx4_jump_count(p->devinfo, elk_last_inst, (yyvsp[-1].integer));
		elk_set_src1(p, elk_last_inst, elk_imm_d((yyvsp[-1].integer)));

		if (!p->single_program_flow)
			elk_inst_set_thread_control(p->devinfo, elk_last_inst,
						    ELK_THREAD_SWITCH);

		elk_pop_insn_state(p);
	}
#line 3045 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 123: /* breakinstruction: predicate BREAK execsize JUMP_LABEL JUMP_LABEL instoptions  */
#line 1266 "../src/intel/compiler/elk/elk_gram.y"
        {
		add_label(p, (yyvsp[-2].string), INSTR_LABEL_JIP);
		add_label(p, (yyvsp[-1].string), INSTR_LABEL_UIP);

		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));

		if (p->devinfo->ver >= 8) {
			elk_set_dest(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src0(p, elk_last_inst, elk_imm_d(0x0));
		} else {
			elk_set_dest(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src0(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));
		}

		elk_pop_insn_state(p);
	}
#line 3072 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 124: /* breakinstruction: predicate BREAK execsize relativelocation relativelocation instoptions  */
#line 1289 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));

		elk_set_dest(p, elk_last_inst, elk_ip_reg());
		elk_set_src0(p, elk_last_inst, elk_ip_reg());
		elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));
		elk_inst_set_gfx4_jump_count(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_inst_set_gfx4_pop_count(p->devinfo, elk_last_inst, (yyvsp[-1].integer));

		elk_pop_insn_state(p);
	}
#line 3090 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 125: /* breakinstruction: predicate HALT execsize JUMP_LABEL JUMP_LABEL instoptions  */
#line 1303 "../src/intel/compiler/elk/elk_gram.y"
        {
		add_label(p, (yyvsp[-2].string), INSTR_LABEL_JIP);
		add_label(p, (yyvsp[-1].string), INSTR_LABEL_UIP);

		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));

		elk_set_dest(p, elk_last_inst, retype(elk_null_reg(),
			     ELK_REGISTER_TYPE_D));

		if (p->devinfo->ver < 8) {
			elk_set_src0(p, elk_last_inst, retype(elk_null_reg(),
				     ELK_REGISTER_TYPE_D));
			elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));
		} else {
			elk_set_src0(p, elk_last_inst, elk_imm_d(0x0));
		}

		elk_pop_insn_state(p);
	}
#line 3116 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 126: /* breakinstruction: predicate CONT execsize JUMP_LABEL JUMP_LABEL instoptions  */
#line 1325 "../src/intel/compiler/elk/elk_gram.y"
        {
		add_label(p, (yyvsp[-2].string), INSTR_LABEL_JIP);
		add_label(p, (yyvsp[-1].string), INSTR_LABEL_UIP);

		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));
		elk_set_dest(p, elk_last_inst, elk_ip_reg());

		if (p->devinfo->ver >= 8) {
			elk_set_src0(p, elk_last_inst, elk_imm_d(0x0));
		} else {
			elk_set_src0(p, elk_last_inst, elk_ip_reg());
			elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));
		}

		elk_pop_insn_state(p);
	}
#line 3139 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 127: /* breakinstruction: predicate CONT execsize relativelocation relativelocation instoptions  */
#line 1344 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-4].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-3].integer));
		elk_set_dest(p, elk_last_inst, elk_ip_reg());

		elk_set_src0(p, elk_last_inst, elk_ip_reg());
		elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));

		elk_inst_set_gfx4_jump_count(p->devinfo, elk_last_inst, (yyvsp[-2].integer));
		elk_inst_set_gfx4_pop_count(p->devinfo, elk_last_inst, (yyvsp[-1].integer));

		elk_pop_insn_state(p);
	}
#line 3158 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 128: /* loopinstruction: predicate WHILE execsize JUMP_LABEL instoptions  */
#line 1363 "../src/intel/compiler/elk/elk_gram.y"
        {
		add_label(p, (yyvsp[-1].string), INSTR_LABEL_JIP);

		elk_next_insn(p, (yyvsp[-3].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-2].integer));

		if (p->devinfo->ver >= 8) {
			elk_set_dest(p, elk_last_inst,
						retype(elk_null_reg(),
						ELK_REGISTER_TYPE_D));
			elk_set_src0(p, elk_last_inst, elk_imm_d(0x0));
		} else if (p->devinfo->ver == 7) {
			elk_set_dest(p, elk_last_inst,
						retype(elk_null_reg(),
						ELK_REGISTER_TYPE_D));
			elk_set_src0(p, elk_last_inst,
						retype(elk_null_reg(),
						ELK_REGISTER_TYPE_D));
			elk_set_src1(p, elk_last_inst,
						elk_imm_w(0x0));
		} else {
			elk_set_dest(p, elk_last_inst, elk_imm_w(0x0));
			elk_set_src0(p, elk_last_inst,
						retype(elk_null_reg(),
						ELK_REGISTER_TYPE_D));
			elk_set_src1(p, elk_last_inst,
						retype(elk_null_reg(),
						ELK_REGISTER_TYPE_D));
		}

		elk_pop_insn_state(p);
	}
#line 3196 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 129: /* loopinstruction: predicate WHILE execsize relativelocation instoptions  */
#line 1397 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-3].integer));
		i965_asm_set_instruction_options(p, (yyvsp[0].options));
		elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-2].integer));

		elk_set_dest(p, elk_last_inst, elk_ip_reg());
		elk_set_src0(p, elk_last_inst, elk_ip_reg());
		elk_set_src1(p, elk_last_inst, elk_imm_d(0x0));
		elk_inst_set_gfx4_jump_count(p->devinfo, elk_last_inst, (yyvsp[-1].integer));
		elk_inst_set_gfx4_pop_count(p->devinfo, elk_last_inst, 0);

		elk_pop_insn_state(p);
	}
#line 3214 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 130: /* loopinstruction: DO execsize instoptions  */
#line 1411 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_next_insn(p, (yyvsp[-2].integer));
		if (p->devinfo->ver < 6) {
			elk_inst_set_exec_size(p->devinfo, elk_last_inst, (yyvsp[-1].integer));
			i965_asm_set_instruction_options(p, (yyvsp[0].options));
			elk_set_dest(p, elk_last_inst, elk_null_reg());
			elk_set_src0(p, elk_last_inst, elk_null_reg());
			elk_set_src1(p, elk_last_inst, elk_null_reg());

			elk_inst_set_qtr_control(p->devinfo, elk_last_inst, ELK_COMPRESSION_NONE);
		}
	}
#line 3231 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 133: /* simple_int: INTEGER  */
#line 1432 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = (yyvsp[0].integer); }
#line 3237 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 134: /* simple_int: MINUS INTEGER  */
#line 1433 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = -(yyvsp[0].integer); }
#line 3243 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 135: /* simple_int: LONG  */
#line 1434 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = (yyvsp[0].llint); }
#line 3249 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 136: /* simple_int: MINUS LONG  */
#line 1435 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.integer) = -(yyvsp[0].llint); }
#line 3255 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 138: /* rellocation: %empty  */
#line 1440 "../src/intel/compiler/elk/elk_gram.y"
                      { (yyval.integer) = 0; }
#line 3261 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 139: /* relativelocation: simple_int  */
#line 1445 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.integer) = (yyvsp[0].integer);
	}
#line 3269 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 140: /* jumplabel: JUMP_LABEL  */
#line 1451 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.string) = (yyvsp[0].string); }
#line 3275 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 141: /* jumplabel: %empty  */
#line 1452 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.string) = NULL; }
#line 3281 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 142: /* jumplabeltarget: JUMP_LABEL_TARGET  */
#line 1457 "../src/intel/compiler/elk/elk_gram.y"
        {
		struct target_label *label = rzalloc(p->mem_ctx, struct target_label);

		label->name = ralloc_strdup(p->mem_ctx, (yyvsp[0].string));
		label->offset = p->next_insn_offset;

		list_addtail(&label->link, &target_labels);
	}
#line 3294 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 145: /* dstoperand: dstreg dstregion writemask reg_type  */
#line 1475 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = (yyvsp[-3].reg);
		(yyval.reg).vstride = ELK_VERTICAL_STRIDE_1;
		(yyval.reg).width = ELK_WIDTH_1;
		(yyval.reg).hstride = (yyvsp[-2].integer);
		(yyval.reg).type = (yyvsp[0].reg_type);
		(yyval.reg).writemask = (yyvsp[-1].integer);
		(yyval.reg).swizzle = ELK_SWIZZLE_NOOP;
		(yyval.reg).subnr = (yyval.reg).subnr * elk_reg_type_to_size((yyvsp[0].reg_type));
	}
#line 3309 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 146: /* dstoperandex: dstoperandex_typed dstregion writemask reg_type  */
#line 1489 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = (yyvsp[-3].reg);
		(yyval.reg).hstride = (yyvsp[-2].integer);
		(yyval.reg).type = (yyvsp[0].reg_type);
		(yyval.reg).writemask = (yyvsp[-1].integer);
		(yyval.reg).subnr = (yyval.reg).subnr * elk_reg_type_to_size((yyvsp[0].reg_type));
	}
#line 3321 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 147: /* dstoperandex: nullreg dstregion writemask reg_type  */
#line 1501 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = (yyvsp[-3].reg);
		(yyval.reg).vstride = ELK_VERTICAL_STRIDE_1;
		(yyval.reg).width = ELK_WIDTH_1;
		(yyval.reg).hstride = (yyvsp[-2].integer);
		(yyval.reg).writemask = (yyvsp[-1].integer);
		(yyval.reg).type = (yyvsp[0].reg_type);
	}
#line 3334 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 148: /* dstoperandex: threadcontrolreg  */
#line 1510 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = (yyvsp[0].reg);
		(yyval.reg).hstride = 1;
		(yyval.reg).type = ELK_REGISTER_TYPE_UW;
	}
#line 3344 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 159: /* dstreg: directgenreg  */
#line 1532 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = (yyvsp[0].reg);
		(yyval.reg).address_mode = ELK_ADDRESS_DIRECT;
	}
#line 3353 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 160: /* dstreg: indirectgenreg  */
#line 1537 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = (yyvsp[0].reg);
		(yyval.reg).address_mode = ELK_ADDRESS_REGISTER_INDIRECT_REGISTER;
	}
#line 3362 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 161: /* dstreg: directmsgreg  */
#line 1542 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = (yyvsp[0].reg);
		(yyval.reg).address_mode = ELK_ADDRESS_DIRECT;
	}
#line 3371 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 162: /* dstreg: indirectmsgreg  */
#line 1547 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = (yyvsp[0].reg);
		(yyval.reg).address_mode = ELK_ADDRESS_REGISTER_INDIRECT_REGISTER;
	}
#line 3380 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 165: /* immreg: immval imm_type  */
#line 1561 "../src/intel/compiler/elk/elk_gram.y"
        {
		switch ((yyvsp[0].reg_type)) {
		case ELK_REGISTER_TYPE_UD:
			(yyval.reg) = elk_imm_ud((yyvsp[-1].llint));
			break;
		case ELK_REGISTER_TYPE_D:
			(yyval.reg) = elk_imm_d((yyvsp[-1].llint));
			break;
		case ELK_REGISTER_TYPE_UW:
			(yyval.reg) = elk_imm_uw((yyvsp[-1].llint) | ((yyvsp[-1].llint) << 16));
			break;
		case ELK_REGISTER_TYPE_W:
			(yyval.reg) = elk_imm_w((yyvsp[-1].llint));
			break;
		case ELK_REGISTER_TYPE_F:
			(yyval.reg) = elk_imm_reg(ELK_REGISTER_TYPE_F);
			/* Set u64 instead of ud since DIM uses a 64-bit F-typed imm */
			(yyval.reg).u64 = (yyvsp[-1].llint);
			break;
		case ELK_REGISTER_TYPE_V:
			(yyval.reg) = elk_imm_v((yyvsp[-1].llint));
			break;
		case ELK_REGISTER_TYPE_UV:
			(yyval.reg) = elk_imm_uv((yyvsp[-1].llint));
			break;
		case ELK_REGISTER_TYPE_VF:
			(yyval.reg) = elk_imm_vf((yyvsp[-1].llint));
			break;
		case ELK_REGISTER_TYPE_Q:
			(yyval.reg) = elk_imm_q((yyvsp[-1].llint));
			break;
		case ELK_REGISTER_TYPE_UQ:
			(yyval.reg) = elk_imm_uq((yyvsp[-1].llint));
			break;
		case ELK_REGISTER_TYPE_DF:
			(yyval.reg) = elk_imm_reg(ELK_REGISTER_TYPE_DF);
			(yyval.reg).d64 = (yyvsp[-1].llint);
			break;
		case ELK_REGISTER_TYPE_HF:
			(yyval.reg) = elk_imm_reg(ELK_REGISTER_TYPE_HF);
			(yyval.reg).ud = (yyvsp[-1].llint) | ((yyvsp[-1].llint) << 16);
			break;
		default:
			error(&(yylsp[0]), "Unknown immediate type %s\n",
			      elk_reg_type_to_letters((yyvsp[0].reg_type)));
		}
	}
#line 3432 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 166: /* reg32: directgenreg region reg_type  */
#line 1612 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = set_direct_src_operand(&(yyvsp[-2].reg), (yyvsp[0].reg_type));
		(yyval.reg) = stride((yyval.reg), (yyvsp[-1].reg).vstride, (yyvsp[-1].reg).width, (yyvsp[-1].reg).hstride);
	}
#line 3441 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 176: /* directsrcaccoperand: negate abs accreg region reg_type  */
#line 1641 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = set_direct_src_operand(&(yyvsp[-2].reg), (yyvsp[0].reg_type));
		(yyval.reg).negate = (yyvsp[-4].integer);
		(yyval.reg).abs = (yyvsp[-3].integer);
		(yyval.reg).vstride = (yyvsp[-1].reg).vstride;
		(yyval.reg).width = (yyvsp[-1].reg).width;
		(yyval.reg).hstride = (yyvsp[-1].reg).hstride;
	}
#line 3454 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 177: /* srcarcoperandex: srcarcoperandex_typed region reg_type  */
#line 1653 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = elk_reg((yyvsp[-2].reg).file,
			     (yyvsp[-2].reg).nr,
			     (yyvsp[-2].reg).subnr,
			     0,
			     0,
			     (yyvsp[0].reg_type),
			     (yyvsp[-1].reg).vstride,
			     (yyvsp[-1].reg).width,
			     (yyvsp[-1].reg).hstride,
			     ELK_SWIZZLE_NOOP,
			     WRITEMASK_XYZW);
	}
#line 3472 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 178: /* srcarcoperandex: nullreg region reg_type  */
#line 1667 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = set_direct_src_operand(&(yyvsp[-2].reg), (yyvsp[0].reg_type));
		(yyval.reg).vstride = (yyvsp[-1].reg).vstride;
		(yyval.reg).width = (yyvsp[-1].reg).width;
		(yyval.reg).hstride = (yyvsp[-1].reg).hstride;
	}
#line 3483 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 179: /* srcarcoperandex: threadcontrolreg  */
#line 1674 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = set_direct_src_operand(&(yyvsp[0].reg), ELK_REGISTER_TYPE_UW);
	}
#line 3491 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 186: /* indirectsrcoperand: negate abs indirectgenreg indirectregion swizzle reg_type  */
#line 1690 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = elk_reg((yyvsp[-3].reg).file,
			     0,
			     (yyvsp[-3].reg).subnr,
			     (yyvsp[-5].integer),  // negate
			     (yyvsp[-4].integer),  // abs
			     (yyvsp[0].reg_type),
			     (yyvsp[-2].reg).vstride,
			     (yyvsp[-2].reg).width,
			     (yyvsp[-2].reg).hstride,
			     (yyvsp[-1].integer),
			     WRITEMASK_X);

		(yyval.reg).address_mode = ELK_ADDRESS_REGISTER_INDIRECT_REGISTER;
		// elk_reg set indirect_offset to 0 so set it to valid value
		(yyval.reg).indirect_offset = (yyvsp[-3].reg).indirect_offset;
	}
#line 3513 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 192: /* directsrcoperand: negate abs directgenreg_list region swizzle reg_type  */
#line 1719 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = elk_reg((yyvsp[-3].reg).file,
			     (yyvsp[-3].reg).nr,
			     (yyvsp[-3].reg).subnr,
			     (yyvsp[-5].integer),
			     (yyvsp[-4].integer),
			     (yyvsp[0].reg_type),
			     (yyvsp[-2].reg).vstride,
			     (yyvsp[-2].reg).width,
			     (yyvsp[-2].reg).hstride,
			     (yyvsp[-1].integer),
			     WRITEMASK_X);
	}
#line 3531 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 194: /* addrparam: addrreg exp  */
#line 1738 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
		(yyval.reg).subnr = (yyvsp[-1].reg).subnr;
		(yyval.reg).indirect_offset = (yyvsp[0].integer);
	}
#line 3541 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 196: /* exp: INTEGER  */
#line 1748 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = (yyvsp[0].integer); }
#line 3547 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 197: /* exp: LONG  */
#line 1749 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = (yyvsp[0].llint); }
#line 3553 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 198: /* subregnum: DOT exp  */
#line 1753 "../src/intel/compiler/elk/elk_gram.y"
                                        { (yyval.integer) = (yyvsp[0].integer); }
#line 3559 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 199: /* subregnum: %empty  */
#line 1754 "../src/intel/compiler/elk/elk_gram.y"
                                        { (yyval.integer) = 0; }
#line 3565 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 200: /* directgenreg: GENREG subregnum  */
#line 1759 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
		(yyval.reg).file = ELK_GENERAL_REGISTER_FILE;
		(yyval.reg).nr = (yyvsp[-1].integer);
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3576 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 201: /* indirectgenreg: GENREGFILE LSQUARE addrparam RSQUARE  */
#line 1769 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
		(yyval.reg).file = ELK_GENERAL_REGISTER_FILE;
		(yyval.reg).subnr = (yyvsp[-1].reg).subnr;
		(yyval.reg).indirect_offset = (yyvsp[-1].reg).indirect_offset;
	}
#line 3587 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 202: /* directmsgreg: MSGREG subregnum  */
#line 1779 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg).file = ELK_MESSAGE_REGISTER_FILE;
		(yyval.reg).nr = (yyvsp[-1].integer);
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3597 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 203: /* indirectmsgreg: MSGREGFILE LSQUARE addrparam RSQUARE  */
#line 1788 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
		(yyval.reg).file = ELK_MESSAGE_REGISTER_FILE;
		(yyval.reg).subnr = (yyvsp[-1].reg).subnr;
		(yyval.reg).indirect_offset = (yyvsp[-1].reg).indirect_offset;
	}
#line 3608 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 204: /* addrreg: ADDRREG subregnum  */
#line 1798 "../src/intel/compiler/elk/elk_gram.y"
        {
		int subnr = (p->devinfo->ver >= 8) ? 16 : 8;

		if ((yyvsp[0].integer) > subnr)
			error(&(yylsp[0]), "Address sub register number %d"
				   "out of range\n", (yyvsp[0].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_ADDRESS;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3624 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 205: /* accreg: ACCREG subregnum  */
#line 1813 "../src/intel/compiler/elk/elk_gram.y"
        {
		int nr_reg;
		if (p->devinfo->ver < 8)
			nr_reg = 2;
		else
			nr_reg = 10;

		if ((yyvsp[-1].integer) > nr_reg)
			error(&(yylsp[-1]), "Accumulator register number %d"
				   " out of range\n", (yyvsp[-1].integer));

		memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_ACCUMULATOR;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3645 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 206: /* flagreg: FLAGREG subregnum  */
#line 1833 "../src/intel/compiler/elk/elk_gram.y"
        {
		// SNB = 1 flag reg and IVB+ = 2 flag reg
		int nr_reg = (p->devinfo->ver >= 7) ? 2 : 1;
		int subnr = nr_reg;

		if ((yyvsp[-1].integer) > nr_reg)
			error(&(yylsp[-1]), "Flag register number %d"
				   " out of range \n", (yyvsp[-1].integer));
		if ((yyvsp[0].integer) > subnr)
			error(&(yylsp[0]), "Flag subregister number %d"
				   " out of range\n", (yyvsp[0].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_FLAG | (yyvsp[-1].integer);
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3666 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 207: /* maskreg: MASKREG subregnum  */
#line 1853 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-1].integer) > 0)
			error(&(yylsp[-1]), "Mask register number %d"
				   " out of range\n", (yyvsp[-1].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_MASK;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3680 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 208: /* notifyreg: NOTIFYREG subregnum  */
#line 1866 "../src/intel/compiler/elk/elk_gram.y"
        {
		int subnr = 3;
		if ((yyvsp[0].integer) > subnr)
			error(&(yylsp[0]), "Notification sub register number %d"
				   " out of range\n", (yyvsp[0].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_NOTIFICATION_COUNT;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3695 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 209: /* statereg: STATEREG subregnum  */
#line 1880 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-1].integer) > 2)
			error(&(yylsp[-1]), "State register number %d"
				   " out of range\n", (yyvsp[-1].integer));

		if ((yyvsp[0].integer) > 4)
			error(&(yylsp[0]), "State sub register number %d"
				   " out of range\n", (yyvsp[0].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_STATE;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3713 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 210: /* controlreg: CONTROLREG subregnum  */
#line 1897 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[0].integer) > 3)
			error(&(yylsp[0]), "control sub register number %d"
				   " out of range\n", (yyvsp[0].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_CONTROL;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3727 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 211: /* ipreg: IPREG  */
#line 1909 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg) = elk_ip_reg(); }
#line 3733 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 212: /* nullreg: NULL_TOKEN  */
#line 1913 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg) = elk_null_reg(); }
#line 3739 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 213: /* threadcontrolreg: THREADREG subregnum  */
#line 1918 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[0].integer) > 7)
			error(&(yylsp[0]), "Thread control sub register number %d"
				   " out of range\n", (yyvsp[0].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_TDR;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3753 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 214: /* performancereg: PERFORMANCEREG subregnum  */
#line 1931 "../src/intel/compiler/elk/elk_gram.y"
        {
		int subnr;
		if (p->devinfo->ver <= 8)
			subnr = 3;
		else
			subnr = 4;

		if ((yyvsp[0].integer) > subnr)
			error(&(yylsp[0]), "Performance sub register number %d"
				   " out of range\n", (yyvsp[0].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_TIMESTAMP;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3773 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 215: /* channelenablereg: CHANNELENABLEREG subregnum  */
#line 1950 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-1].integer) > 0)
			error(&(yylsp[-1]), "Channel enable register number %d"
				   " out of range\n", (yyvsp[-1].integer));

		(yyval.reg).file = ELK_ARCHITECTURE_REGISTER_FILE;
		(yyval.reg).nr = ELK_ARF_MASK;
		(yyval.reg).subnr = (yyvsp[0].integer);
	}
#line 3787 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 216: /* immval: exp2  */
#line 1964 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.llint) = (yyvsp[0].llint);
	}
#line 3795 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 217: /* immval: LSQUARE exp2 COMMA exp2 COMMA exp2 COMMA exp2 RSQUARE  */
#line 1968 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.llint) = ((yyvsp[-7].llint) << 0) | ((yyvsp[-5].llint) << 8) | ((yyvsp[-3].llint) << 16) | ((yyvsp[-1].llint) << 24);
	}
#line 3803 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 218: /* dstregion: %empty  */
#line 1976 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.integer) = ELK_HORIZONTAL_STRIDE_1;
	}
#line 3811 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 219: /* dstregion: LANGLE exp RANGLE  */
#line 1980 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
			error(&(yylsp[-1]), "Invalid Horizontal stride %d\n", (yyvsp[-1].integer));

		(yyval.integer) = ffs((yyvsp[-1].integer));
	}
#line 3822 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 222: /* region: %empty  */
#line 1995 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.reg) = stride((yyval.reg), 0, 1, 0);
	}
#line 3830 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 223: /* region: LANGLE exp RANGLE  */
#line 1999 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 32 || !isPowerofTwo((yyvsp[-1].integer))))
			error(&(yylsp[-1]), "Invalid VertStride %d\n", (yyvsp[-1].integer));

		(yyval.reg) = stride((yyval.reg), (yyvsp[-1].integer), 1, 0);
	}
#line 3841 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 224: /* region: LANGLE exp COMMA exp COMMA exp RANGLE  */
#line 2006 "../src/intel/compiler/elk/elk_gram.y"
        {

		if ((yyvsp[-5].integer) != 0 && ((yyvsp[-5].integer) > 32 || !isPowerofTwo((yyvsp[-5].integer))))
			error(&(yylsp[-5]), "Invalid VertStride %d\n", (yyvsp[-5].integer));

		if ((yyvsp[-3].integer) > 16 || !isPowerofTwo((yyvsp[-3].integer)))
			error(&(yylsp[-3]), "Invalid width %d\n", (yyvsp[-3].integer));

		if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
			error(&(yylsp[-1]), "Invalid Horizontal stride in"
				   "  region_wh %d\n", (yyvsp[-1].integer));

		(yyval.reg) = stride((yyval.reg), (yyvsp[-5].integer), (yyvsp[-3].integer), (yyvsp[-1].integer));
	}
#line 3860 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 225: /* region: LANGLE exp SEMICOLON exp COMMA exp RANGLE  */
#line 2021 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-5].integer) != 0 && ((yyvsp[-5].integer) > 32 || !isPowerofTwo((yyvsp[-5].integer))))
			error(&(yylsp[-5]), "Invalid VertStride %d\n", (yyvsp[-5].integer));

		if ((yyvsp[-3].integer) > 16 || !isPowerofTwo((yyvsp[-3].integer)))
			error(&(yylsp[-3]), "Invalid width %d\n", (yyvsp[-3].integer));

		if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
			error(&(yylsp[-1]), "Invalid Horizontal stride in"
				   " region_wh %d\n", (yyvsp[-1].integer));

		(yyval.reg) = stride((yyval.reg), (yyvsp[-5].integer), (yyvsp[-3].integer), (yyvsp[-1].integer));
	}
#line 3878 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 226: /* region: LANGLE VxH COMMA exp COMMA exp RANGLE  */
#line 2035 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-3].integer) > 16 || !isPowerofTwo((yyvsp[-3].integer)))
			error(&(yylsp[-3]), "Invalid width %d\n", (yyvsp[-3].integer));

		if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
			error(&(yylsp[-1]), "Invalid Horizontal stride in"
				   " region_wh %d\n", (yyvsp[-1].integer));

		(yyval.reg) = elk_VxH_indirect(0, 0);
	}
#line 3893 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 227: /* region_wh: LANGLE exp COMMA exp RANGLE  */
#line 2049 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-3].integer) > 16 || !isPowerofTwo((yyvsp[-3].integer)))
			error(&(yylsp[-3]), "Invalid width %d\n", (yyvsp[-3].integer));

		if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
			error(&(yylsp[-1]), "Invalid Horizontal stride in"
				   " region_wh %d\n", (yyvsp[-1].integer));

		(yyval.reg) = stride((yyval.reg), 0, (yyvsp[-3].integer), (yyvsp[-1].integer));
		(yyval.reg).vstride = ELK_VERTICAL_STRIDE_ONE_DIMENSIONAL;
	}
#line 3909 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 228: /* reg_type: TYPE_F  */
#line 2063 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_F;  }
#line 3915 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 229: /* reg_type: TYPE_UD  */
#line 2064 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_UD; }
#line 3921 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 230: /* reg_type: TYPE_D  */
#line 2065 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_D;  }
#line 3927 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 231: /* reg_type: TYPE_UW  */
#line 2066 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_UW; }
#line 3933 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 232: /* reg_type: TYPE_W  */
#line 2067 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_W;  }
#line 3939 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 233: /* reg_type: TYPE_UB  */
#line 2068 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_UB; }
#line 3945 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 234: /* reg_type: TYPE_B  */
#line 2069 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_B;  }
#line 3951 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 235: /* reg_type: TYPE_DF  */
#line 2070 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_DF; }
#line 3957 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 236: /* reg_type: TYPE_UQ  */
#line 2071 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_UQ; }
#line 3963 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 237: /* reg_type: TYPE_Q  */
#line 2072 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_Q;  }
#line 3969 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 238: /* reg_type: TYPE_HF  */
#line 2073 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_HF; }
#line 3975 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 239: /* reg_type: TYPE_NF  */
#line 2074 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_NF; }
#line 3981 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 240: /* imm_type: reg_type  */
#line 2078 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = (yyvsp[0].reg_type); }
#line 3987 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 241: /* imm_type: TYPE_V  */
#line 2079 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_V;  }
#line 3993 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 242: /* imm_type: TYPE_VF  */
#line 2080 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_VF; }
#line 3999 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 243: /* imm_type: TYPE_UV  */
#line 2081 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.reg_type) = ELK_REGISTER_TYPE_UV; }
#line 4005 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 244: /* writemask: %empty  */
#line 2086 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.integer) = WRITEMASK_XYZW;
	}
#line 4013 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 245: /* writemask: DOT writemask_x writemask_y writemask_z writemask_w  */
#line 2090 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.integer) = (yyvsp[-3].integer) | (yyvsp[-2].integer) | (yyvsp[-1].integer) | (yyvsp[0].integer);
	}
#line 4021 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 246: /* writemask_x: %empty  */
#line 2096 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 0; }
#line 4027 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 247: /* writemask_x: X  */
#line 2097 "../src/intel/compiler/elk/elk_gram.y"
                { (yyval.integer) = 1 << ELK_CHANNEL_X; }
#line 4033 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 248: /* writemask_y: %empty  */
#line 2101 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 0; }
#line 4039 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 249: /* writemask_y: Y  */
#line 2102 "../src/intel/compiler/elk/elk_gram.y"
                { (yyval.integer) = 1 << ELK_CHANNEL_Y; }
#line 4045 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 250: /* writemask_z: %empty  */
#line 2106 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 0; }
#line 4051 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 251: /* writemask_z: Z  */
#line 2107 "../src/intel/compiler/elk/elk_gram.y"
                { (yyval.integer) = 1 << ELK_CHANNEL_Z; }
#line 4057 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 252: /* writemask_w: %empty  */
#line 2111 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 0; }
#line 4063 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 253: /* writemask_w: W  */
#line 2112 "../src/intel/compiler/elk/elk_gram.y"
                { (yyval.integer) = 1 << ELK_CHANNEL_W; }
#line 4069 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 254: /* swizzle: %empty  */
#line 2117 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.integer) = ELK_SWIZZLE_NOOP;
	}
#line 4077 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 255: /* swizzle: DOT chansel  */
#line 2121 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.integer) = ELK_SWIZZLE4((yyvsp[0].integer), (yyvsp[0].integer), (yyvsp[0].integer), (yyvsp[0].integer));
	}
#line 4085 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 256: /* swizzle: DOT chansel chansel chansel chansel  */
#line 2125 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.integer) = ELK_SWIZZLE4((yyvsp[-3].integer), (yyvsp[-2].integer), (yyvsp[-1].integer), (yyvsp[0].integer));
	}
#line 4093 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 261: /* predicate: %empty  */
#line 2140 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_push_insn_state(p);
		elk_set_default_predicate_control(p, ELK_PREDICATE_NONE);
		elk_set_default_flag_reg(p, 0, 0);
		elk_set_default_predicate_inverse(p, false);
	}
#line 4104 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 262: /* predicate: LPAREN predstate flagreg predctrl RPAREN  */
#line 2147 "../src/intel/compiler/elk/elk_gram.y"
        {
		elk_push_insn_state(p);
		elk_set_default_predicate_inverse(p, (yyvsp[-3].integer));
		elk_set_default_flag_reg(p, (yyvsp[-2].reg).nr, (yyvsp[-2].reg).subnr);
		elk_set_default_predicate_control(p, (yyvsp[-1].integer));
	}
#line 4115 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 263: /* predstate: %empty  */
#line 2156 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 0; }
#line 4121 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 264: /* predstate: PLUS  */
#line 2157 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 0; }
#line 4127 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 265: /* predstate: MINUS  */
#line 2158 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 1; }
#line 4133 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 266: /* predctrl: %empty  */
#line 2162 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = ELK_PREDICATE_NORMAL; }
#line 4139 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 267: /* predctrl: DOT X  */
#line 2163 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = ELK_PREDICATE_ALIGN16_REPLICATE_X; }
#line 4145 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 268: /* predctrl: DOT Y  */
#line 2164 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = ELK_PREDICATE_ALIGN16_REPLICATE_Y; }
#line 4151 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 269: /* predctrl: DOT Z  */
#line 2165 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = ELK_PREDICATE_ALIGN16_REPLICATE_Z; }
#line 4157 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 270: /* predctrl: DOT W  */
#line 2166 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = ELK_PREDICATE_ALIGN16_REPLICATE_W; }
#line 4163 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 283: /* negate: %empty  */
#line 2183 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 0; }
#line 4169 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 284: /* negate: MINUS  */
#line 2184 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 1; }
#line 4175 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 285: /* abs: %empty  */
#line 2188 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = 0; }
#line 4181 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 286: /* abs: ABS  */
#line 2189 "../src/intel/compiler/elk/elk_gram.y"
                { (yyval.integer) = 1; }
#line 4187 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 287: /* cond_mod: condModifiers  */
#line 2195 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.condition).cond_modifier = (yyvsp[0].integer);
		(yyval.condition).flag_reg_nr = 0;
		(yyval.condition).flag_subreg_nr = 0;
	}
#line 4197 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 288: /* cond_mod: condModifiers DOT flagreg  */
#line 2201 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.condition).cond_modifier = (yyvsp[-2].integer);
		(yyval.condition).flag_reg_nr = (yyvsp[0].reg).nr;
		(yyval.condition).flag_subreg_nr = (yyvsp[0].reg).subnr;
	}
#line 4207 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 289: /* condModifiers: %empty  */
#line 2209 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = ELK_CONDITIONAL_NONE; }
#line 4213 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 301: /* msgdesc: MSGDESC_BEGIN msgdesc_parts MSGDESC_END  */
#line 2225 "../src/intel/compiler/elk/elk_gram.y"
                                                { (yyval.msgdesc) = (yyvsp[-1].msgdesc); }
#line 4219 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 302: /* msgdesc_parts: SRC1_LEN ASSIGN INTEGER msgdesc_parts  */
#line 2230 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.msgdesc) = (yyvsp[0].msgdesc);
		(yyval.msgdesc).src1_len = (yyvsp[-1].integer);
	}
#line 4228 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 303: /* msgdesc_parts: EX_BSO msgdesc_parts  */
#line 2235 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.msgdesc) = (yyvsp[0].msgdesc);
		(yyval.msgdesc).ex_bso = 1;
	}
#line 4237 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 304: /* msgdesc_parts: INTEGER msgdesc_parts  */
#line 2239 "../src/intel/compiler/elk/elk_gram.y"
                                { (yyval.msgdesc) = (yyvsp[0].msgdesc); }
#line 4243 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 305: /* msgdesc_parts: ASSIGN msgdesc_parts  */
#line 2240 "../src/intel/compiler/elk/elk_gram.y"
                               { (yyval.msgdesc) = (yyvsp[0].msgdesc); }
#line 4249 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 306: /* msgdesc_parts: %empty  */
#line 2242 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.msgdesc), 0, sizeof((yyval.msgdesc)));
	}
#line 4257 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 307: /* saturate: %empty  */
#line 2248 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = ELK_INSTRUCTION_NORMAL; }
#line 4263 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 308: /* saturate: SATURATE  */
#line 2249 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.integer) = ELK_INSTRUCTION_SATURATE; }
#line 4269 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 309: /* execsize: %empty  */
#line 2255 "../src/intel/compiler/elk/elk_gram.y"
        {
		(yyval.integer) = 0;
	}
#line 4277 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 310: /* execsize: LPAREN exp2 RPAREN  */
#line 2259 "../src/intel/compiler/elk/elk_gram.y"
        {
		if ((yyvsp[-1].llint) > 32 || !isPowerofTwo((yyvsp[-1].llint)))
			error(&(yylsp[-1]), "Invalid execution size %llu\n", (yyvsp[-1].llint));

		(yyval.integer) = cvt((yyvsp[-1].llint)) - 1;
	}
#line 4288 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 311: /* instoptions: %empty  */
#line 2270 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.options), 0, sizeof((yyval.options)));
	}
#line 4296 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 312: /* instoptions: LCURLY instoption_list RCURLY  */
#line 2274 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.options), 0, sizeof((yyval.options)));
		(yyval.options) = (yyvsp[-1].options);
	}
#line 4305 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 313: /* instoption_list: instoption_list COMMA instoption  */
#line 2282 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.options), 0, sizeof((yyval.options)));
		(yyval.options) = (yyvsp[-2].options);
		add_instruction_option(&(yyval.options), (yyvsp[0].instoption));
	}
#line 4315 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 314: /* instoption_list: instoption_list instoption  */
#line 2288 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.options), 0, sizeof((yyval.options)));
		(yyval.options) = (yyvsp[-1].options);
		add_instruction_option(&(yyval.options), (yyvsp[0].instoption));
	}
#line 4325 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 315: /* instoption_list: %empty  */
#line 2294 "../src/intel/compiler/elk/elk_gram.y"
        {
		memset(&(yyval.options), 0, sizeof((yyval.options)));
	}
#line 4333 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 316: /* instoption: ALIGN1  */
#line 2300 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = ALIGN1;}
#line 4339 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 317: /* instoption: ALIGN16  */
#line 2301 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = ALIGN16; }
#line 4345 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 318: /* instoption: ACCWREN  */
#line 2303 "../src/intel/compiler/elk/elk_gram.y"
        {
		if (p->devinfo->ver < 6)
			error(&(yylsp[0]), "AccWrEnable not supported before Gfx6\n");
		(yyval.instoption).uint_value = ACCWREN;
	}
#line 4355 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 319: /* instoption: SECHALF  */
#line 2308 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = SECHALF; }
#line 4361 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 320: /* instoption: COMPR  */
#line 2309 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = COMPR; }
#line 4367 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 321: /* instoption: COMPR4  */
#line 2310 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = COMPR4; }
#line 4373 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 322: /* instoption: BREAKPOINT  */
#line 2311 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = BREAKPOINT; }
#line 4379 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 323: /* instoption: NODDCLR  */
#line 2312 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = NODDCLR; }
#line 4385 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 324: /* instoption: NODDCHK  */
#line 2313 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = NODDCHK; }
#line 4391 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 325: /* instoption: MASK_DISABLE  */
#line 2314 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = MASK_DISABLE; }
#line 4397 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 326: /* instoption: EOT  */
#line 2315 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = EOT; }
#line 4403 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 327: /* instoption: SWITCH  */
#line 2316 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = SWITCH; }
#line 4409 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 328: /* instoption: ATOMIC  */
#line 2317 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = ATOMIC; }
#line 4415 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 329: /* instoption: BRANCH_CTRL  */
#line 2319 "../src/intel/compiler/elk/elk_gram.y"
        {
		if (p->devinfo->ver < 8)
			error(&(yylsp[0]), "BranchCtrl not supported before Gfx8\n");
		(yyval.instoption).uint_value = BRANCH_CTRL;
	}
#line 4425 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 330: /* instoption: CMPTCTRL  */
#line 2324 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = CMPTCTRL; }
#line 4431 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 331: /* instoption: WECTRL  */
#line 2325 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = WECTRL; }
#line 4437 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 332: /* instoption: QTR_2Q  */
#line 2326 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_2Q; }
#line 4443 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 333: /* instoption: QTR_3Q  */
#line 2327 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_3Q; }
#line 4449 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 334: /* instoption: QTR_4Q  */
#line 2328 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_4Q; }
#line 4455 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 335: /* instoption: QTR_2H  */
#line 2329 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_2H; }
#line 4461 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 336: /* instoption: QTR_2N  */
#line 2330 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_2N; }
#line 4467 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 337: /* instoption: QTR_3N  */
#line 2331 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_3N; }
#line 4473 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 338: /* instoption: QTR_4N  */
#line 2332 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_4N; }
#line 4479 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 339: /* instoption: QTR_5N  */
#line 2333 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_5N; }
#line 4485 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 340: /* instoption: QTR_6N  */
#line 2334 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_6N; }
#line 4491 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 341: /* instoption: QTR_7N  */
#line 2335 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_7N; }
#line 4497 "src/intel/compiler/elk/elk_gram.tab.c"
    break;

  case 342: /* instoption: QTR_8N  */
#line 2336 "../src/intel/compiler/elk/elk_gram.y"
                        { (yyval.instoption).uint_value = QTR_8N; }
#line 4503 "src/intel/compiler/elk/elk_gram.tab.c"
    break;


#line 4507 "src/intel/compiler/elk/elk_gram.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2339 "../src/intel/compiler/elk/elk_gram.y"


extern int yylineno;

#ifdef YYBYACC
void
yyerror(YYLTYPE *ltype, char *msg)
#else
void
yyerror(char *msg)
#endif
{
	fprintf(stderr, "%s: %d: %s at \"%s\"\n",
	        input_filename, yylineno, msg, lex_text());
	++errors;
}
